'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                  gMap2                                   |
'|                                                                          |
'|    Image marker/annotation based on the GDImage zoom control feature.    |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                           copyright (c) 2014                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 05-09-2011 (MM-DD-YYYY)            |
'|                        Last revised : 09-23-2014 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "gMap2.exe"

#INCLUDE "WIN32API.INC"
#INCLUDE "gdimage.inc"
#INCLUDE "winlift.inc"

'------------------------------------------------------------------------------------------
#RESOURCE "gmap2.pbr"
'------------------------------------------------------------------------------------------

declare function zTrace LIB "zTrace.DLL" alias "zTrace" (zMessage as asciiz) as long

type ColorMatrix
    m(0 to 4, 0 to 4) as single
end type

declare function GdipCreateFromHDC lib "GDIPLUS.DLL" alias "GdipCreateFromHDC" (byval hdc as DWORD, byref graphics as DWORD) as long
declare function GdipSetInterpolationMode lib "GDIPLUS.DLL" alias "GdipSetInterpolationMode" (byval graphics as DWORD, byval interpolationMode as long) as long
declare function GdipDrawImageRectRectI lib "GDIPLUS.DLL" alias "GdipDrawImageRectRectI" (byval graphics as DWORD, byval image as DWORD, byval dstx as long, _
                 byval dsty as long, byval dstwidth as long, byval dstheight as long, byval srcx as long, byval srcy as long, byval srcwidth as long, byval srcheight as long, _
                 byval srcUnit as long, byval imageAttributes as DWORD, byval pCallback as DWORD, byval callbackData as DWORD) as long
declare function GdipDeleteGraphics lib "GDIPLUS.DLL" alias "GdipDeleteGraphics" (byval graphics as DWORD) as long
declare function GdipDisposeImage lib "GDIPLUS.DLL" alias "GdipDisposeImage" (byval img as DWORD) as long
declare function GdipLoadImageFromFile lib "GDIPLUS.DLL" alias "GdipLoadImageFromFile" (zFilName as asciiz, byref nImage as DWORD) as long
declare function GdipGetImageWidth LIB "gdiplus.dll" alias "GdipGetImageWidth" (byval img as DWORD, byref nWidth as long) as long
declare function GdipGetImageHeight LIB "gdiplus.dll" alias "GdipGetImageHeight" (byval img as DWORD, byref Height as long) as long
declare function GdipSetImageAttributesColorMatrix lib "gdiplus.dll" alias "GdipSetImageAttributesColorMatrix" (byval imageattr as DWORD, byval ClrAdjType as long, _
                 byval enableFlag as long, colourMatrix AS ColorMatrix, grayMatrix AS ANY, byval flags as long) as long
declare function GdipCreateImageAttributes lib "gdiplus.dll" alias "GdipCreateImageAttributes" (byref imageattr as DWORD) as long
declare function GdipCreateFontFamilyFromName lib "gdiplus.dll" alias "GdipCreateFontFamilyFromName" (zFontName as ASCIIZ, byval fontCollection as long, fontFamily as long) as long
declare function GdipCreateFont lib "gdiplus.dll" alias "GdipCreateFont" (byval fontFamily as long, byval emSize as single, byval style as long, byval unit as long, createdfont as long) as long
declare function GdipCreateStringFormat lib "gdiplus.dll" alias "GdipCreateStringFormat" (byval formatAttributes as long, byval language as INTEGER, StringFormat as long) as long
declare function GdipMeasureString lib "gdiplus.dll" alias "GdipMeasureString" (byval graphics as long, zString as ASCIIZ, byval length as long, byval thefont as long, layoutRect as RECTF, byval StringFormat as long, boundingBox as RECTF, _
                                                                                codepointsFitted as long, linesFilled as long) as long
declare function GdipDeleteStringFormat lib "gdiplus.dll" alias "GdipDeleteStringFormat" (byval StringFormat as long) as long
declare function GdipDeleteFont lib "gdiplus.dll" alias "GdipDeleteFont" (byval curFont as long) as long
declare function GdipDeleteFontFamily lib "gdiplus.dll" alias "GdipDeleteFontFamily" (byval fontFamily as long) as long


declare function PathCombine lib "SHLWAPI.DLL" alias "PathCombineA" (byref lpszDest as asciiz, byref lpszDir as asciiz, byref lpszFile as asciiz) as long

%UnitPixel                              = 2
%InterpolationModeDefault               = 0
%InterpolationModeLowQuality            = 1
%InterpolationModeHighQuality           = 2
%InterpolationModeBilinear              = 3
%InterpolationModeBicubic               = 4
%InterpolationModeNearestNeighbor       = 5
%InterpolationModeHighQualityBilinear   = 6
%InterpolationModeHighQualityBicubic    = 7

$ZLIM               = "|"
$IMAGE_EXT          = ".bmp.png.jpg.tif.gif."
$Annotation         = "Annotation"

%IDC_CTRL           = -1  '// ZOOM control
%IDC_THUMB          = -2  '// THUMB control
%IDC_CONTACT        = -3  '// CONTACT sheet control
%IDC_SPRITE         = -4  '// SPRITE control
%IDC_RICHEDIT       = -5  '// RICHEDIT help

%ID_THUMB_RECT      = -6  '// Thumb rectangle
%ID_LOGO            = -7  '// Logo

%IDC_MAP_LIST       = 101 '// MAP listbox
%IDC_ZOOM           = 102 '// Thumb zoom slider
%IDC_SPLIT_TOP      = 103 '// Horizontal splitter
%IDC_SPLIT_BOTTOM   = 104 '// Horizontal splitter
%IDC_SPRITE_LIST    = 105 '// SPRITE listbox
%IDC_LISTFNAME      = 106
%IDC_LISTIMAGE      = 107

%IDC_PANNEL         = 108
%IDC_COORD_X        = 109
%IDC_COORD_Y        = 110
%IDC_ID             = 111
%IDC_LABEL          = 112
%IDC_ID_COORD_X     = 113
%IDC_ID_COORD_Y     = 114

%IDC_OPEN           = 115
%IDC_PRINT          = 116
%IDC_SAVEIMAGE      = 117
%IDC_CROP           = 118
%IDC_LOCKSPRITE     = 119
%IDC_SCRIPTSAVE     = 120
%IDC_USERHELP       = 121
'%IDC_USERHELP + 1  = 122
%IDC_CLOSE          = 123
%IDC_SPRITECAPTION  = 124
%IDC_THUMBCAPTION   = 125

%IDM_Note           = 201
'202 --------------------
%IDM_Clipboard      = 203

'// Popup Bitmap menu
%IDM_EditNote       = 301
'302 --------------------
%IDM_EditLabel      = 303
'304 --------------------
%IDM_NextFrame      = 305
'306 --------------------
%IDM_MirrorHorz     = 307
%IDM_MirrorVert     = 308
%IDM_90_Left        = 309
%IDM_90_Right       = 310
'311 --------------------
%IDM_Up             = 312
%IDM_Top            = 313
%IDM_Down           = 314
%IDM_Bottom         = 315
'316 --------------------
%IDM_Flatten        = 317
%IDM_Clone          = 318
%IDM_Lock           = 319
'320 --------------------
%IDM_Delete         = 321

%ID_LEFT_ARROW      = -9998  '// Contact sheet left arrow
%ID_RIGHT_ARROW     = -9999  '// Contact sheet right arrow
%ID_FirstContact    = -10000 '// Start of contact ID

%ID_TOP_ARROW       = -19998 '// Up arrow on sprite sheet
%ID_BOTTOM_ARROW    = -19999 '// Down arrow on contact sheet
%ID_FirstSprite     = -20000 '// Start of sprite sheet ID

%CLIENT_WIDTH       = 1024
%CLIENT_HEIGHT      = 768

%ALPHA_MIN          = 85
%ALPHA_STEP         = 15

%CONTACT_TIMER      = 1
%COLORGRAY          = &H808080

$thb                = "thb_"

type SpriteStruct
    ID           as long               '// The unique sprite object IDentifier
    objtype      as long               '// The object type
    filename     as asciiz * %MAX_PATH '// File of the sprite bitmap
    label        as asciiz * 64        '// Friendly name
    xPos         as long               '// X location
    yPos         as long               '// Y location
    xWidth       as long               '// Width of the sprite object
    yHeight      as long               '// Height of the sprite object
    ARGB         as long               '// ARGB color
    visibility   as long               '// ZS_HIDDEN or ZS_VISIBLE state
    scrollmode   as long               '// True/False scrolling mode
    opacity      as long               '// True/False PNG opacity
    userotate    as long               '// Rotate90FlipNone or Rotate270FlipNone
    flipmode     as long               '// ZD_Reverse (FlipX) or ZD_Flip (FlipY) constant
    angle        as long               '// Rotation angle 0-360
    locked       as long               '// True/False condition
    zorder       as long               '// The z-order value
    scale        as single             '// The scale value
    style        as long               '// The object style
    quality      as long               '// The object quality
    clone        as long               '// The unique ID of the cloned object
    '//
    resizeW      as long               '// Resize width to use
    resizeH      as long               '// Resize height to use
    trueW        as long               '// True width of the native bitmap
    trueH        as long               '// True height of the native bitmap
    selected     as byte               '// Selected status
    strFormat    as long               '// string format
    varop        as byte               '// Variable opacity

    info1        as asciiz * 30
    info2        as asciiz * 30
    info3        as asciiz * 30

    FrameCount   as byte               '// Sprite multi-state
    FrameToUse   as byte               '// Sprite multi-state

    reserved     as asciiz * 14        '// for future extension
end type

type PROP
    hMain           as DWORD
    hCtrl           as DWORD
    hThumb          as DWORD
    hContact        as DWORD
    hSprite         as DWORD
    hHelp           as DWORD

    hThumbParent    as DWORD
    hSpriteParent   as DWORD
    hPannel         as DWORD
    hRemoveFocus    as DWORD
    hInstance       as DWORD

    FocusContactID  as long
    FocusSpriteID   as long
    UseQuality      as long
    zoomMin         as long
    zoomMax         as long
    thumb_xP        as long
    thumb_yP        as long
    thumb_xS        as long
    thumb_yS        as long
    thumb_Xpos      as long
    thumb_Ypos      as long
    MenuLock        as long
    nX              as long
    nY              as long
    nSpriteArrow    as long
    nSpriteMove     as long
    nContactID      as long
    nContactArrow   as long
    nContactMove    as long

    szresource as asciiz * %MAX_PATH
    szdropname as asciiz * %MAX_PATH
    szproject  as asciiz * %MAX_PATH
end type

global gP as PROP
global ga_Sprite() as SpriteStruct

function EXEpath() as string
    static szExepath as asciiz * %MAX_PATH
    if (GetModuleFileName(0, szExepath, %MAX_PATH)) then
        local K, nLen, nPos as long
        nLen = len(szExepath)
        nPos = nLen
        for K = 1 to nLen
            if (asc(szExepath, nPos - K) <> 92) then
                mid$(szExepath, nPos - K, 1) = chr$(0)
            else
                exit for
            end if
        next
    end if
    function = lcase$(szExepath)
end function

function EXEresource() as string
    static szResource as asciiz * %MAX_PATH
    PathCombine(szResource, EXEpath(), "resource\")
    function = szResource
end function

function SpinnerName() as string
    function = EXEresource() + "spinwait.png"
end function

function MakeDir(zRep AS ASCIIZ) as long
    local sChm, sDirectory as string, P1, P2, ErrCode as long

    if left$(zRep, 2) = "\\" then exit function
    sDirectory = RTRIM$(zRep, $Anti)
    if (len(sDirectory)) then
        P1 = 1
        do
           P2 = instr(P1, sDirectory, $Anti)
           if (P2) then
               sChm = mid$(sDirectory, 1, P2& - 1): P1 = P2 + 1
           else
               sChm = sDirectory
           end if
           if (len(dir$(sChm, 16)) = 0) then
               if (CreateDirectory((sChm), byval %NULL) = 0) then
                   ErrCode = GetLastError(): exit DO
               end if
           end if
        loop until P2 = 0
    end if
    function = ErrCode
END function

function EXEmap() as string
    static szResource as asciiz * %MAX_PATH
    PathCombine(szResource, EXEpath(), "map\")
    function = szResource
end function

function EXEcapture() as string
    static szResource as asciiz * %MAX_PATH
    PathCombine(szResource, EXEpath(), "capture\")
    function = szResource
end function

function LastMap() as string
    function = EXEmap() + "last.map"
end function

function SpritePath() as string
    static szResource as asciiz * %MAX_PATH
    PathCombine(szResource, EXEpath(), "sprites\")
    function = szResource
end function

'// Main window minimum horizontal track size
function MinTrackSizeW (byval SizeX as long) as long
    static WasSizeX as long
    if (SizeX) then WasSizeX = SizeX
    function = WasSizeX
end function

'// Main window minimum vertical track size
function MinTrackSizeH (byval SizeY as long) as long
    static WasSizeY as long
    if (SizeY) then WasSizeY = SizeY
    function = WasSizeY
end function

function FileSize(szFileSpec as asciiz) as DWORD
    local fd as WIN32_FIND_DATA
    local nRet, hFind as DWORD
    if (len(szFileSpec)) then
        hFind = FindFirstFile(szFileSpec, fd)
        if (hFind <> %INVALID_HANDLE_VALUE) then
            FindClose(hFind)
            nRet = fd.nFileSizeLow
        end if
    end if
    function = nRet
end function

function ScriptFileName() as string
    local sPath, sFileName as string
    zSplitN(gP.szproject, sPath, sFileName)
    local so as long
    so = instr(-1, sFileName, ".")
    if (so > 0) then sFileName = left$(sFileName, so - 1)
    function = sPath + sFileName + ".gns"
end function

sub ShowSaveButton()
    local hCtrl as DWORD
    hCtrl = GetDlgItem(gP.hPannel, %IDC_SCRIPTSAVE)
    if (IsWindow(hCtrl)) then
        if (IsWindowVisible(hCtrl) = %FALSE) then ShowWindow(hCtrl, %SW_SHOW)
    end if
end sub

sub HideSaveButton()
    local hCtrl as DWORD
    hCtrl = GetDlgItem(gP.hPannel, %IDC_SCRIPTSAVE)
    if (IsWindow(hCtrl)) then
        if (IsWindowVisible(hCtrl)) then ShowWindow(hCtrl, %SW_HIDE)
    end if
end sub

function IsFrench() as long
    L$ = space$(6)
    GetLocaleInfo(%LOCALE_USER_DEFAULT, %LOCALE_SENGLANGUAGE, byval strptr(L$), len(L$))
    if (ucase$(L$) = "FRENCH") then function = -1
end function

function GoodMsg(sFrench as string, sEnglish as string) as string
    if (IsFrench()) then function = sFrench else function = sEnglish
end function

sub ShallWeSave()
    local hCtrl as DWORD, szMsg as asciiz * 128
    hCtrl = GetDlgItem(gP.hPannel, %IDC_SCRIPTSAVE)
    if (IsWindow(hCtrl)) then
        if (IsWindowVisible(hCtrl)) then
            szMsg = GoodMsg("|Le projet " + ucase$(pathname$(NAMEX, ScriptFileName())) + " a chang.||Souhaitez-vous enregistrer les modifications ?","|The " + ucase$(pathname$(NAMEX, ScriptFileName())) + " project has changed.||Do you want to save it ?")
            REPLACE $ZLIM WITH $CRLF IN szMsg
            if (skDialogYesNo("", szMsg, "")) then
                SpriteArraySave()
            end if
        end if
    end if
end sub

sub SpriteArrayGet(byval nID as long)
    local zItem as ZOBJECT
    ZD_GetObjectProperties(nID, zItem)                   '// Retrieves all the details about a GDImage sprite object in one single step.
    ga_Sprite(nID).ID = nID                              '// The unique sprite object IDentifier
    ga_Sprite(nID).objtype = zItem.objType               '// The object type (bitmap, text, arrow, curve, rectangle, ellipse, polypolyline)
    ga_Sprite(nID).label = zItem.objLabel                '// Friendly name
    ga_Sprite(nID).xPos = zItem.x1                       '// X location
    ga_Sprite(nID).yPos = zItem.y1                       '// Y location
    ga_Sprite(nID).xWidth = zItem.x2                     '// Width of the sprite object
    ga_Sprite(nID).yHeight = zItem.y2                    '// Height of the sprite object
    ga_Sprite(nID).ARGB = zItem.useARGB                  '// ARGB color
    ga_Sprite(nID).visibility = zItem.visible            '// ZS_HIDDEN or ZS_VISIBLE state
    if (zItem.Style and %ZS_SCROLL) = %ZS_SCROLL then    '// Scrolling mode
        ga_Sprite(nID).scrollmode = -1
    else
        ga_Sprite(nID).scrollmode = 0
    end if
    ga_Sprite(nID).opacity = zItem.opacity               '// True/False PNG opacity
    ga_Sprite(nID).userotate = zItem.userotate           '// Rotate90FlipNone or Rotate270FlipNone
    ga_Sprite(nID).flipmode = zItem.flipmode             '// True/False condition
    ga_Sprite(nID).angle = zItem.angle                   '// Rotation angle 0-360
    ga_Sprite(nID).locked = zItem.locked                 '// True/False condition
    ga_Sprite(nID).zorder = zItem.order                  '// The z-order value
    ga_Sprite(nID).scale = zItem.scale                   '// The scale value
    ga_Sprite(nID).style = zItem.Style                   '// The object style
    ga_Sprite(nID).quality = zItem.quality               '// The object quality
    ga_Sprite(nID).clone = zItem.clone                   '// The unique ID of the cloned object

    ga_Sprite(nID).FrameCount = zItem.FrameCount
    ga_Sprite(nID).FrameToUse = zItem.FrameToUse

    ga_Sprite(nID).selected = 0                          '// Set selected status to Off
end sub

sub SpriteArrayInit(byval nID as long, szSpriteFileName as asciiz)
    ga_Sprite(nID).filename = lcase$(szSpriteFileName)
    SpriteArrayGet(nID)
end sub

sub SpriteArrayLoad()
    local nID, BufferSize, fHandle, K, ObjectType, hBitmap, nFontUse3D, nFontUseSize, ByttesReaded, nObjectCount as long
    local szFileName as asciiz * %MAX_PATH
    local sTextToUse, sFontUseName as string

    szFileName = ScriptFileName()
    if (zExist(szFileName)) then
        BufferSize = FileSize(szFileName)
        if (BufferSize) then

            nObjectCount = BufferSize \ sizeof(SpriteStruct)
            redim ga_Sprite(1 to nObjectCount) as SpriteStruct

            if (zFOpen(szFileName, 0, 2, fHandle) = 0) then
                ReadFile(fHandle, byval varptr(ga_Sprite(1)), BufferSize, ByttesReaded, byval %NULL)
                zFClose(fHandle): fHandle = 0
            end if
            local SpriteNull as SpriteStruct
            for nID = 1 to nObjectCount
                ga_Sprite(nID).ID = nID '// The unique sprite object IDentifier

                ObjectType = ga_Sprite(nID).objtype
                if (ObjectType = %OBJECT_BITMAP) then
                    if (ga_Sprite(nID).clone = 0) then
                        ga_Sprite(nID).filename = lcase$(ga_Sprite(nID).filename) '// Lower(gs_SpritePath + fExtractPath(ga_Sprite(nID).filename, fFileName + fExtension))
                        '// Check if we must resize the OBJECT_BITMAP
                        if ((ga_Sprite(nID).resizeW = ga_Sprite(nID).trueW) and (ga_Sprite(nID).resizeH = ga_Sprite(nID).trueH)) then
                            ga_Sprite(nID).resizeW = 0: ga_Sprite(nID).resizeH = 0
                            ga_Sprite(nID).trueW = 0: ga_Sprite(nID).trueH = 0
                        end if
                        if ((ga_Sprite(nID).resizeW > 0) and (ga_Sprite(nID).resizeH > 0)) then
                            hBitmap = ZI_ResizeBitmapFromFile(ga_Sprite(nID).filename, ga_Sprite(nID).resizeW, ga_Sprite(nID).resizeH)
                        else
                            hBitmap = ZI_CreateBitmapFromFile(ga_Sprite(nID).filename, 0, 0)
                        end if
                        if (hBitmap) then
                            ZD_DrawBitmapToCtrl(gP.hCtrl, ga_Sprite(nID).xPos, ga_Sprite(nID).yPos, hBitmap, ga_Sprite(nID).ARGB, nID, %ZS_VISIBLE)
                        else
                            ga_Sprite(nID) = SpriteNull '// Le sprite a t effac du disque...
                            ShowSaveButton()            '// On montre le bouton "Enregistre" car il faut mettre le script  jour !
                        end if
                    else
                        ZD_CloneObject(ga_Sprite(nID).clone, nID, ga_Sprite(nID).xPos, ga_Sprite(nID).yPos)
                    end if

                elseif (ObjectType = %OBJECT_TEXTBITMAP) then
                    if (ga_Sprite(nID).clone = 0) then
                        nFontUseSize = val(parse$(ga_Sprite(nID).filename, $ZLIM, 1))
                        nFontUse3D = val(parse$(ga_Sprite(nID).filename, $ZLIM, 2))
                        sFontUseName = parse$(ga_Sprite(nID).filename, $ZLIM, 3)
                        sTextToUse = parse$(ga_Sprite(nID).filename, $ZLIM, 4)
                        if len(sTextToUse) = 0 then sTextToUse = ga_Sprite(nID).label
                        hBitmap = ZD_CreateBitmapFromText((sTextToUse), (sFontUseName), nFontUseSize, ga_Sprite(nID).ARGB, nFontUse3D, 0)
                        if (hBitmap) then
                            ZD_DrawTextBitmapToCtrl(gP.hCtrl, ga_Sprite(nID).xPos, ga_Sprite(nID).yPos, hBitmap, ga_Sprite(nID).ARGB, nID, %ZS_VISIBLE)
                        end if
                    else
                        ZD_CloneObject(ga_Sprite(nID).clone, nID, ga_Sprite(nID).xPos, ga_Sprite(nID).yPos)
                    end if
                end if
                ZD_SetObjectRotation(nID, ga_Sprite(nID).userotate)      '// Rotate90FlipNone or Rotate270FlipNone
                ZD_SetObjectFlipMode(nID, ga_Sprite(nID).flipmode)       '// ZD_Reverse or ZD_Flip constant

                ga_Sprite(nID).selected = 0                              '// Set selected status to Off

                local zItem as ZOBJECT
                ZD_GetObjectProperties(nID, zItem)                       '// Retrieve properties
                if (ga_Sprite(nID).scrollmode) then
                    zItem.Style = zItem.Style or %ZS_SCROLL              '// Scrolling mode
                end if
                ga_Sprite(nID).ID = nID                                  '// The unique sprite object IDentifier
                zItem.objType = ga_Sprite(nID).objtype                   '// The object type (bitmap, text, arrow, curve, rectangle, ellipse, polypolyline)
                zItem.objLabel = ga_Sprite(nID).label                    '// Friendly name
                zItem.x1 = ga_Sprite(nID).xPos                           '// X location
                zItem.y1 = ga_Sprite(nID).yPos                           '// Y location
                zItem.useARGB = ga_Sprite(nID).ARGB                      '// ARGB color
                zItem.visible = ga_Sprite(nID).visibility                '// ZS_HIDDEN or ZS_VISIBLE state
                zItem.opacity = ga_Sprite(nID).opacity                   '// True/False PNG opacity
                zItem.angle = ga_Sprite(nID).angle                       '// Rotation angle 0-360
                zItem.locked = ga_Sprite(nID).locked                     '// True/False condition
                zItem.order = ga_Sprite(nID).zorder                      '// The z-order value
                zItem.scale = ga_Sprite(nID).scale                       '// The scale value
                zItem.Style = ga_Sprite(nID).style                       '// The object style
                zItem.quality = ga_Sprite(nID).quality                   '// The object quality
                zItem.FrameCount = ga_Sprite(nID).FrameCount
                zItem.FrameToUse = ga_Sprite(nID).FrameToUse
                zItem.clone = ga_Sprite(nID).clone                       '// The unique nID of the cloned object
                zItem.selected = ga_Sprite(nID).selected                 '// Set selected status to Off

                ZD_SetObjectProperties(nID, zItem)                       '// Update properties
            next
        end if
    end if
end sub

sub SpriteArraySave()
    local TrueCount, K, J, nID, DeleteFlag, BufferSize, ByttesWritten, fHandle as long
    local szFileName as asciiz * %MAX_PATH
    TrueCount = 0
    DeleteFlag = 0
    for K = ubound(ga_Sprite) to 1 step -1
        nID = ga_Sprite(K).ID
        if nID then
           TrueCount += 1
           SpriteArrayGet(nID)
        else
           DeleteFlag = -1
           ARRAY DELETE ga_Sprite(K) '// Remove the deleted sprite object from the global sprite array
           for J = 1 to ubound(ga_Sprite)
               if ga_Sprite(J).clone > K then '// We must shift down the clone pointer
                  ga_Sprite(J).clone = ga_Sprite(J).clone - 1
               end if
           next
       end if
    next

    '// Save full array directly from memory pointer to disk in one single write step (BSAVE)
    szFileName = ScriptFileName()
    if (TrueCount) then
        if (DeleteFlag) then
            for K = 1 to ubound(ga_Sprite)
                ga_Sprite(K).ID = K '// Update the unique nID for further retrieval
            next
        end if
        fHandle = CreateFile(szFileName, %GENERIC_WRITE, 0, byval %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (fHandle <> %INVALID_HANDLE_VALUE) then
            BufferSize = sizeof(SpriteStruct) * ubound(ga_Sprite)
            WriteFile(fHandle, byval varptr(ga_Sprite(1)), BufferSize, ByttesWritten, byval %NULL)
            zFClose(fHandle): fHandle = 0
        end if
    else
        '// If there is no sprite object and the GNS file exist, then remove it from disk
        if (zExist(szFileName)) then
            DeleteFile(szFileName)
        end if
    end if
    HideSaveButton()
end sub

sub LoadProject(szFileName as asciiz, byval rPercent as single)
    if (len(szFileName)) then
        local nID, xPicSize, yPicSize, fHandle, nPos as long
        local hDCsrce, hBitmap, hZoom, dwBytesWritten as DWORD
        local rZoomValue as single
        local lpr as RECT

        '// Delete any existing sprite object before loading a new set
        ZI_DeleteCtrlObject(gP.hCtrl)   '// Delete all objects previously associated to the GDImage control
        HideSaveButton()                '// Hide the save button
        if (ubound(ga_Sprite)) then ERASE ga_Sprite() '// Clear the global Sprite array

        ZI_SetFromFileEx(gP.hCtrl, szFileName, 3000, 3000)
        hDCsrce = ZI_GetDC(gP.hCtrl)
        if (hDCsrce) then
            '// On rcupre la taille du bitmap de fond (la carte)
            ZI_GetBitmapSize(ZI_GetBitmapFromDC(hDCsrce), xPicSize, yPicSize)

            local XPos, YPos, xSize, ySize as long

            ZI_SetFromFile(gP.hThumb, szFileName)
            '// Refresh %ID_THUMB
            ZI_UpdateWindow(gP.hThumb, 0)

            '// Save the thumb coordinates
            GetClientRect(gP.hThumb, lpr)
            ZI_Iconise(xPicSize, yPicSize, lpr.nRight, lpr.nBottom, gP.thumb_xP, gP.thumb_yP, gP.thumb_xS, gP.thumb_yS)

            '// Update trackbar bounds based on image size
            GetClientRect(gP.hCtrl, lpr)
            hZoom = GetDlgItem(gP.hThumbParent, %IDC_ZOOM)
            ZI_Iconise(xPicSize, yPicSize, lpr.nRight, lpr.nBottom, XPos, YPos, xSize, ySize)
            gP.zoomMin = ((xSize - 24) / xPicSize) * 1000
            gP.zoomMax = 1000
            SendMessage(hZoom, %TBM_SETRANGE, %TRUE, mak(long, gP.zoomMin, gP.zoomMax))
            SendMessage(hZoom, %TBM_SETPOS, %TRUE, gP.zoomMin)

            if (rPercent > 0) then
                nPos = (gP.zoomMax - gP.zoomMin) * rPercent + gP.zoomMin
                SendMessage(hZoom, %TBM_SETPOS, %TRUE, nPos)
                rZoomValue = nPos * 0.001
                ZI_SetZoomValue(gP.hCtrl, rZoomValue)
                ZI_SetZoomScrollInfo(gP.hCtrl, 0, rZoomValue)
            end if
            GDImageDrawThumbRect()

            '// On ajoute les sprites fixes, qui ne sont pas affects par le zoom
            hBitmap = ZI_CreateBitmapFromFile(EXEresource() + "logo.png", xPicSize, yPicSize)
            if (hBitmap) then
                nID = %ID_LOGO
                ZD_DrawBitmapToCtrl(gP.hCtrl, 0, 0, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)
                '// Lock and disable the sprite image.
                ZD_SetObjectLocked(nID, %TRUE)
                '// Do not alter the size and location of this object in case of Zoom control.
                ZD_SetObjectHidden(nID, %TRUE) '// Hidden object is a special class of sprite object, they are unaffected by the zoom factor.
            end if

            '// On vrifie qu'il existe un fichier .gns pour cette carte, si oui on charge les sprites.
            SpriteArrayLoad()
            '// On affiche.
            ZI_UpdateWindow(gP.hCtrl, 0)

            '// On sauvegarde le nom de la dernire carte utilise.
            fHandle = CreateFile(LastMap(), %GENERIC_WRITE, 0, byval %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
            if (fHandle <> %INVALID_HANDLE_VALUE) then
                WriteFile(fHandle, szFileName, len(szFileName), dwBytesWritten, byval %NULL)
                zFClose(fHandle): fHandle = 0
            end if

        end if

    end if
end sub

sub GDImageDrawThumbRect()
    local x, y, w, h, nhBitmap, nZoomWidth, nZoomHeight, nW, nH, nPos as long
    local rZoomValue, rOldZoomValue, rRatio as single
    local lpr as RECT

    '// UseThisZoom
    nPos = SendMessage(GetDlgItem(gP.hThumbParent, %IDC_ZOOM), %TBM_GetPos, 0, 0)
    rOldZoomValue = ZI_GetZoomValue(gP.hCtrl)
    rZoomValue = nPos / 1000
    ZI_SetZoomValue(gP.hCtrl, rZoomValue)
    ZI_SetZoomScrollInfo(gP.hCtrl, rOldZoomValue, rZoomValue)

    'rZoomValue = ZI_GetZoomValue(gP.hCtrl)
    GetClientRect(gP.hCtrl, lpr)
    ZI_GetImageSizeFromControl(gP.hCtrl, nW, nH)

    nZoomWidth = nW * rZoomValue
    nZoomHeight = nH * rZoomValue

    rRatio = gP.thumb_xS / nZoomWidth

    x = ZI_GetXscroll(gP.hCtrl)
    y = ZI_GetYscroll(gP.hCtrl)
    if ((nZoomWidth < lpr.nRight) or (nZoomHeight < lpr.nBottom)) then
        if (nZoomWidth < lpr.nRight) then x -= (lpr.nRight - nZoomWidth) \ 2
        if (nZoomHeight < lpr.nBottom) then y -= (lpr.nBottom - nZoomHeight) \ 2
    end if
    x = x * rRatio + gP.thumb_xP
    y = y * rRatio + gP.thumb_yP
    w = lpr.nRight * rRatio
    h = lpr.nBottom * rRatio

    ZD_GetObjectBound(%ID_THUMB_RECT, nW, nH)
    if ((nW <> w) or (nH <> h)) then
        '// We build the view-port rectangle
        '// it is made of 2 objects:
        '//   - a solid red frame       nObject(1)
        '//   - a translucent rectangle nObject(2) being used to move the view port around
        redim tObject(1 to 2) as ZOBJECT
        ZI_CreateRectangleObject(tObject(1), 0, 0, w, h, ZD_ColorARGB(16, RGB(16, 16, 16)), 1, %ZS_VISIBLE, %ZD_DRAW_FILLED, 0)
        ZI_CreateRectangleObject(tObject(2), 0, 0, w, h, ZD_ColorARGB(192, RGB(255, 0, 0)), 1, %ZS_VISIBLE, %ZD_DRAW_OUTLINE, 0)

        nhBitmap = ZI_CreateImageComposited("", w, h, byval varptr(tObject(1)), ubound(tObject()) - LBOUND(tObject()) + 1)
        if (nhBitmap) then
            ZD_DrawBitmapToCtrl(gP.hThumb, x, y, nhBitmap, ZD_ColorARGB(255, 0), %ID_THUMB_RECT, %ZS_VISIBLE)
            ZI_UpdateWindow(gP.hThumb, 0)
        end if
    else
        ZD_SetObjectXY(%ID_THUMB_RECT, x, y, 1)
    end if
end sub

sub GDImageEnableEvents()
    local cpCallBack as DWORD
    cpCallBack = codeptr(GDImageCallBack)
    ZI_EventMessage(cpCallBack, %WM_LBUTTONDOWN, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_RBUTTONDOWN, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_KEYDOWN, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_MOUSEMOVE, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_HSCROLL, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_VSCROLL, %TRUE)

    ZI_EventMessage(cpCallBack, %WM_MEASUREITEM, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_DRAWITEM, %TRUE)
end sub

sub SpriteClearSelection()
    local K as long
    for K = 1 to ubound(ga_Sprite)
        if (ga_Sprite(K).ID) then ga_Sprite(K).selected = 0
    next
    ZI_ClearObjectSelected(gP.hCtrl)
end sub

function SetImageAlpha (byval Alpha as long) as DWORD
    local c as ColorMatrix, T as single, imgAttr as DWORD
    T = Alpha / 255
    GdipCreateImageAttributes(imgAttr)
    c.m(0, 0) = 1: c.m(1, 0) = 0: c.m(2, 0) = 0: c.m(3, 0) = 0: c.m(4, 0) = 0
    c.m(0, 1) = 0: c.m(1, 1) = 1: c.m(2, 1) = 0: c.m(3, 1) = 0: c.m(4, 1) = 0
    c.m(0, 2) = 0: c.m(1, 2) = 0: c.m(2, 2) = 1: c.m(3, 2) = 0: c.m(4, 2) = 0
    c.m(0, 3) = 0: c.m(1, 3) = 0: c.m(2, 3) = 0: c.m(3, 3) = T: c.m(4, 3) = 0
    c.m(0, 4) = 0: c.m(1, 4) = 0: c.m(2, 4) = 0: c.m(3, 4) = 0: c.m(4, 4) = 1
    if (GdipSetImageAttributesColorMatrix(imgAttr, 0, 1, c, byval %NULL, 0) = 0) then
        function = imgAttr
    end if
end function

function CallBack_Ctrl(byval hWnd as long, byval Msg as long, byval wParam as DWORD, byval lParam as long) as long
    local lpr as RECT
    local x, y, x1, y1, ObjectType, nRet, nObjectID, nState, nStateCount, nObjectType, MenuChoice as long
    local rZoomValue as single
    local nW, nH, nZoomWidth, nZoomHeight, xOffset, yOffset, xCurrentScroll, yCurrentScroll, nSelected as long
    local sLabelName as string
    local hCtrl as DWORD
    local p as POINT

    local img, graphics, ImgAttr as DWORD
    local imgW, imgH as long
    local zTxt AS ASCIIZ * 128
    local lpmis as MEASUREITEMSTRUCT PTR
    local lpdis as DRAWITEMSTRUCT PTR

    static sWasLabelName as string

    nObjectID = ZI_MouseOverObjectID()

    select case long Msg
    case %WM_MEASUREITEM
         lpmis = lParam
         if (wParam = 0) then '// wParam = 0, means this is a Menu
             @lpmis.itemWidth = 130
             @lpmis.itemHeight = 18
             function = 1: exit function
         end if

    case %WM_DRAWITEM
         lpdis = lParam
         select case long @lpdis.CtlType
         case %ODT_MENU '// 1 Owner-drawn menu item
              img = GetMenuIcon(@lpdis.ItemID)
              zTxt = GetMenuText(@lpdis.ItemID)

              if (@lpdis.itemState and %ODS_SELECTED) then
                  SetTextColor(@lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT))
                  SetBkColor(@lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHT))
              else
                  SetTextColor(@lpdis.hDC, GetSysColor(%COLOR_MENUTEXT))
                  SetBkColor(@lpdis.hDC, GetSysColor(%COLOR_MENU))
              end if

              if (@lpdis.itemState and %ODS_GRAYED) then
                  SetTextColor(@lpdis.hDC, GetSysColor(%COLOR_GRAYTEXT))
                  ImgAttr = SetImageAlpha(80)
              end if

              ExtTextOut(@lpdis.hDC, 6 + 16 + @lpdis.rcItem.nleft, _
                         @lpdis.rcItem.nTop + 1, %ETO_OPAQUE, _
                         @lpdis.rcItem, zTxt, LEN(zTxt), byval %NULL)

              if (GdipCreateFromHDC(@lpdis.hDC, graphics) = 0) then
                  GdipGetImageWidth(img, imgW): GdipGetImageHeight(img, imgH)
                  GdipDrawImageRectRectI(graphics, img, _
                                         @lpdis.rcItem.nleft + 1, @lpdis.rcItem.nTop + 1, imgW, imgH, _
                                         0, 0, imgW, imgH, %UnitPixel, ImgAttr, 0, 0)
                  GdipDeleteGraphics(graphics)
              end if

              function = 1: exit function

         end select

    case %WM_LBUTTONDOWN
         if (nObjectID) then
             if (nObjectID <> %IDC_CTRL) then
                 nSelected = ZD_GetObjectSelected(nObjectID)
                 if (ZI_IsCtrlKeyPressed()) then
                     if (nSelected )then nSelected = 1
                     ga_Sprite(nObjectID).selected = nSelected
                 end if
             else
                 if ZI_IsCtrlKeyPressed() = 0 then SpriteClearSelection()
             end if
         end if
    case %WM_LBUTTONDBLCLK
         '// if we have any sprite
         if ((ZI_GetCtrlObjectCount(hWnd)) and (nObjectID > 0)) then
             nStateCount = ZD_GetObjectFrameCount(nObjectID)
             if (nStateCount > 1) then
                 nState = ZD_GetObjectFrameToUse(nObjectID) + 1: if nState > nStateCount then nState = 1
                 ZD_SetObjectFrameToUse(nObjectID, nState, %TRUE)
             end if
         end if

    case %WM_RBUTTONDOWN
         x = lo(INTEGER, lParam): y = hi(INTEGER, lParam)
         if (nObjectID) then
             GetCursorPos(p)
             if (nObjectID <> %IDC_CTRL) then
                 nObjectType = ZD_GetObjectType(nObjectID)

                 hCtrl = CreatePopupMenu() '// The bitmap popup menu
                 if (hCtrl) then
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_EditNote   , GetMenuText(%IDM_EditNote))
                     AppendMenu(hCtrl, %MF_SEPARATOR, 0               , "")
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_EditLabel  , GetMenuText(%IDM_EditLabel))
                     AppendMenu(hCtrl, %MF_SEPARATOR, 0               , "")
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_NextFrame  , GetMenuText(%IDM_NextFrame))
                     AppendMenu(hCtrl, %MF_SEPARATOR, 0               , "")
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_MirrorHorz , GetMenuText(%IDM_MirrorHorz))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_MirrorVert , GetMenuText(%IDM_MirrorVert))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_90_Left    , GetMenuText(%IDM_90_Left))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_90_Right   , GetMenuText(%IDM_90_Right))
                     AppendMenu(hCtrl, %MF_SEPARATOR, 0               , "")
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Up         , GetMenuText(%IDM_Up))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Top        , GetMenuText(%IDM_Top))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Down       , GetMenuText(%IDM_Down))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Bottom     , GetMenuText(%IDM_Bottom))
                     AppendMenu(hCtrl, %MF_SEPARATOR, 0               , "")
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Flatten    , GetMenuText(%IDM_Flatten))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Clone      , GetMenuText(%IDM_Clone))
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Lock       , GetMenuText(%IDM_Lock))
                     AppendMenu(hCtrl, %MF_SEPARATOR, 0               , "")
                     AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Delete     , GetMenuText(%IDM_Delete))

                     if (nObjectType = %OBJECT_TEXTBITMAP) then
                         EnableMenuItem(hCtrl, %IDM_EditNote, %MF_ENABLED)
                     else
                         EnableMenuItem(hCtrl, %IDM_EditNote, %MF_GRAYED)
                     end if

                     if (ZD_GetObjectLocked(nObjectID)) then
                         gP.MenuLock = -1
                     else
                         gP.MenuLock = 0
                     end if

                     if (ZD_GetObjectFrameCount(nObjectID) > 1) then
                         EnableMenuItem(hCtrl, %IDM_NextFrame, %MF_ENABLED)
                     else
                         EnableMenuItem(hCtrl, %IDM_NextFrame, %MF_GRAYED)
                     end if

                     EnableMenuItem(hCtrl, %IDM_Flatten, %MF_GRAYED)

                     MenuChoice = TrackPopupMenuEx(hCtrl, %TPM_RETURNCMD, p.x, p.y, gP.hCtrl, byval %NULL)
                     DestroyMenu(hCtrl)
                     if (MenuChoice) then SendMessage(gP.hMain, %WM_COMMAND, mak(long, MenuChoice, 0), 0)
                 end if

             else
                 ScreenToClient(gP.hCtrl, p)
                 GetClientRect(gP.hCtrl, lpr)
                 if (PtInRect(lpr, p)) then

                     hCtrl = CreatePopupMenu()
                     if (hCtrl) then
                         AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Note       , GetMenuText(%IDM_Note))
                         AppendMenu(hCtrl, %MF_SEPARATOR, 0               , "")
                         AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_Clipboard  , GetMenuText(%IDM_Clipboard))

                         EnableMenuItem(hCtrl, %IDM_Clipboard, %MF_GRAYED)
                         if OpenClipboard(byval %NULL) then
                            if (EnumClipboardFormats(%CF_BITMAP)) then
                                EnableMenuItem(hCtrl, %IDM_Clipboard, %MF_ENABLED)
                            end if
                            CloseClipboard()
                         end if

                         '// CODE USED TO COMPUTE THE CORRECT X,Y LOCATION
                         '// Get current Zoom value
                         rZoomValue = ZI_GetZoomValue(gP.hCtrl)
                         '// Retrieve the size of the memory bitmap
                         ZI_GetImageSizeFromControl(gP.hCtrl, nW, nH)
                         '// Compute x,y offset
                         nZoomWidth = nW * rZoomValue
                         nZoomHeight = nH * rZoomValue
                         xOffset = 0: yOffset = 0
                         if ((nZoomWidth < lpr.nRight) or (nZoomHeight < lpr.nBottom)) then
                             if (nZoomWidth < lpr.nRight) then xOffset = clng((lpr.nRight - nZoomWidth) * 0.5)
                             if (nZoomHeight < lpr.nBottom) then yOffset = clng((lpr.nBottom - nZoomHeight) * 0.5)
                         end if
                         '// Retrieve scroll values
                         xCurrentScroll = ZI_GetXscroll(gP.hCtrl)
                         yCurrentScroll = ZI_GetYscroll(gP.hCtrl)
                         '// Now we can compute the correct coordinates for the annotation.
                         gP.nX = clng((p.x + xCurrentScroll - xOffset) / rZoomValue)
                         gP.nY = clng((p.y + yCurrentScroll - yOffset) / rZoomValue)

                         GetCursorPos(p)
                         MenuChoice = TrackPopupMenuEx(hCtrl, %TPM_RETURNCMD, p.x, p.y, gP.hCtrl, byval %NULL)
                         DestroyMenu(hCtrl)
                         if (MenuChoice) then SendMessage(gP.hMain, %WM_COMMAND, mak(long, MenuChoice, 0), 0)

                     end if
                 end if
             end if
         end if

    case %WM_MOUSEMOVE
         if (nObjectID = %IDC_CTRL) then
             GDImageDrawThumbRect()
             if (len(sWasLabelName)) then
                 sWasLabelName = "": ZI_SetToolTipText(hWnd, (sWasLabelName))
                 if (IsWindowEnabled(GetDlgItem(gP.hPannel, %IDC_LABEL)) = %FALSE) then
                     SetWindowText(GetDlgItem(gP.hPannel, %IDC_LABEL), "")
                     SetWindowText(GetDlgItem(gP.hPannel, %IDC_ID), "")
                     SetWindowText(GetDlgItem(gP.hPannel, %IDC_ID_COORD_X), "")
                     SetWindowText(GetDlgItem(gP.hPannel, %IDC_ID_COORD_Y), "")
                     ZI_UpdateWindow(gP.hPannel, 0)
                 end if
             end if
         end if
         if (nObjectID > 0) then
             sLabelName = ZD_GetObjectImageLabel(nObjectID)
             '// Display the object tooltip.
             if (sLabelName <> sWasLabelName) then
                 ZI_SetToolTipText(hWnd, (sLabelName))

                 hCtrl = GetDlgItem(gP.hPannel, %IDC_LABEL)
                 if (IsWindowEnabled(hCtrl) = %FALSE) then SetWindowText(hCtrl, (sLabelName))

                 SetWindowText(GetDlgItem(gP.hThumbParent, %IDC_THUMBCAPTION), (sLabelName))
                 SetWindowText(GetDlgItem(gP.hPannel, %IDC_ID), str$(nObjectID))
                 local nX, nY as long
                 ZD_GetObjectXY(nObjectID, nX, nY)
                 SetWindowText(GetDlgItem(gP.hPannel, %IDC_ID_COORD_X), str$(nX) + " ")
                 SetWindowText(GetDlgItem(gP.hPannel, %IDC_ID_COORD_Y), str$(nY))
             end if
             sWasLabelName = sLabelName
             if (ZI_IsLButtonDown()) then
                 if (ZD_ObjectMouseCaptured()) = nObjectID then ShowSaveButton()
             end if
         end if
         DisplayMouseXY(hWnd, lo(INTEGER, lParam), hi(INTEGER, lParam))

    case %WM_KEYDOWN
         nObjectID = ZI_GetObjectFocusID() '// On rcupre l'ID du sprite qui a le focus
         if (nObjectID) then '// Handle the sprites move
             ZD_GetObjectXY(nObjectID, x, y)
             x1 = x '// Make a copy to preserve original value
             y1 = y '// Make a copy to preserve original value
             '// Check if keyboard accelerator keys are yeld down
             local UseStep as long
             if (ZI_IsCtrlKeyPressed()) then
                 UseStep = 4
                 if (ZI_IsShiftKeyPressed()) then UseStep = 16
             elseif (ZI_IsShiftKeyPressed()) then
                 UseStep = 2
             else
                 UseStep = 1
             end if
             local useWidth, useHeight as long
             '// Does the sprite must move with the background?
             if (ZD_GetObjectScroll(nObjectID)) then
                 '// Get the image background size
                 ZI_GetBitmapSize(ZI_GetBMP(gP.hCtrl), useWidth, useHeight)
             else
                 '// Get the client size of the control
                 GetClientRect(gP.hCtrl, lpr)
                 useWidth = lpr.nRight: useHeight = lpr.nBottom
             end if
             local BoundWidth, BoundHeight as long
             '// Retrieve the sprite's size
             ZD_GetObjectBound(nObjectID, BoundWidth, BoundHeight)
             local x2Div2, y2Div2 as long
             x2Div2 = BoundWidth \ 2
             y2Div2 = BoundHeight \ 2
             select case long wParam
             case %VK_HOME
                  x1 = 0
             case %VK_END
                  x1 = max&(useWidth - BoundWidth, 0)
             case %VK_PRIOR
                  y1 = 0
             case %VK_NEXT
                  y1 = max&(useHeight - BoundHeight, 0)
             case %VK_LEFT, %VK_NUMPAD4
                  if x1 > -x2Div2 then x1 = max&(x1 - UseStep, -x2Div2)
             case %VK_UP, %VK_NUMPAD8
                  if y1 > -y2Div2 then y1 = max&(y1 - UseStep, -y2Div2)
             case %VK_RIGHT, %VK_NUMPAD6
                  if x1 < useWidth - x2Div2 then
                     x1 = MIN&(x1 + UseStep, useWidth - x2Div2)
                  end if
             case %VK_DOWN, %VK_NUMPAD2
                  if y1 < useHeight - y2Div2 then
                     y1 = MIN&(y1 + UseStep, useHeight - y2Div2)
                  end if
             end select

             if ((x <> x1) or (y <> y1)) then
                 x = x1: y = y1
                 ZD_SetObjectXY(nObjectID, x1, y1, %TRUE)
                 ShowSaveButton()
             end if

         end if

    case %WM_VSCROLL, %WM_HSCROLL
         GDImageDrawThumbRect()

    end select

    function = nRet

end function

function CallBack_Contact(byval hWnd as long, byval Msg as long, byval wParam as DWORD, byval lParam as long) as long
    local hList, nRet, nObjectID, ObjectType as long
    local sLabelName as string

    static sWasContactLabel as string

    nObjectID = ZI_MouseOverObjectID()

    select case long Msg
    case %WM_LBUTTONDOWN
         if (nObjectID) then
             if (nObjectID < %ID_RIGHT_ARROW) then
                 ObjectType = ZD_GetObjectType(nObjectID)
                 if (ObjectType = %OBJECT_BITMAP) or (ObjectType = %OBJECT_TEXTBITMAP) then
                     if (gP.FocusContactID <> nObjectID) then
                         ShallWeSave()
                         if (gP.FocusContactID < %ID_RIGHT_ARROW) then
                             ZD_SetObjectAlpha(gP.FocusContactID, %ALPHA_MIN, %FALSE)
                         end if
                         hList = GetDlgItem(gP.hMain, %IDC_MAP_LIST)
                         ListSelectPlus(hList, nObjectID)
                         gP.FocusContactID = nObjectID
                         ZD_SetObjectAlpha(gP.FocusContactID, 255, %TRUE)

                         ZI_SpinnerInit(gP.hMain, SpinnerName(), 0)
                             gP.szproject = ListGetText(GetDlgItem(gP.hMain, %IDC_MAP_LIST), %ID_FirstContact - nObjectID + 1)
                             LoadProject(gP.szproject, 0)
                         ZI_SpinnerClose()

                     end if
                 end if
             else
                 if (nObjectID = %ID_LEFT_ARROW) then
                     if (gP.nContactMove = 0) then
                         Ctrl_MapToRight()
                     end if
                 elseif (nObjectID = %ID_RIGHT_ARROW) then
                     if (gP.nContactMove = 0) then
                         Ctrl_MapToLeft()
                     end if
                 end if
             end if
         end if

    case %WM_MOUSEMOVE
         if (nObjectID < %ID_RIGHT_ARROW) then
             if (gP.nContactID <> nObjectID) then
                 gP.nContactID = nObjectID

                 '// Tooltip hover image
                 sLabelName = ZD_GetObjectImageLabel(nObjectID)
                  '// Tooltip hover image
                 if (sLabelName <> sWasContactLabel) then
                     ZI_SetToolTipText(gP.hContact, (sLabelName))
                 end if
                 sWasContactLabel = sLabelName

             end if
         else
             '// Clear the tooltip
             sWasContactLabel = "": ZI_SetToolTipText(gP.hContact, (sWasContactLabel))

             gP.nContactID = 0
             if (nObjectID = %ID_LEFT_ARROW) then
                 if (gP.nContactArrow = 0) then
                     gP.nContactArrow = -1
                     Ctrl_MapLeftRight(1)
                 end if
             elseif (nObjectID = %ID_RIGHT_ARROW) then
                 if (gP.nContactArrow = 0) then
                     gP.nContactArrow = -1
                     Ctrl_MapLeftRight(-1)
                 end if
             end if
         end if
    end select

    hWnd = 0: wParam =0: lParam = 0
    function = nRet
end function

function CallBack_Thumb(byval hWnd as long, byval Msg as long, byval wParam as DWORD, byval lParam as long) as long
    local nRet, nID as long

    nID = ZI_MouseOverObjectID()

    if (nID <> GetDlgCtrlID(hWnd)) then '// We must be hover the red rectangle

        local x, y, w, h, nW, nH, dx, dy, nX, nY, lpX, lpY, UseStep as long
        local sif as SCROLLINFO
        local nZoomWidth, nZoomHeight as long
        local rThumbRatio, rRatio, rZoomValue as single
        local lpr as RECT

        rZoomValue = ZI_GetZoomValue(gP.hCtrl)

        GetClientRect(gP.hCtrl, lpr)

        ZI_GetImageSizeFromControl(gP.hCtrl, nW, nH)

        if (gP.thumb_xS <> 0) then rRatio = (nW * rZoomValue) / gP.thumb_xS

        select case long Msg

        case %WM_MOUSEMOVE
             if (ZI_IsLButtonDown()) then
                 '// Get the sprite size
                 ZD_GetObjectBound(nID, w, h)

                 '// Mouse coordinates
                 lpX = lo(INTEGER, lParam): lpY = hi(INTEGER, lParam)
                 '// Coordonnes XY au moment du clic gauche qui dbute le dplacement.
                 ZD_GetObjectXYcapture(nID, nx, ny)
                 x = lpX - nx: y = lpY - nY

                 '// Adjust the coordinates to stay inside of the zoomed image bounds
                 nZoomWidth = nW * rZoomValue: nZoomHeight = nH * rZoomValue
                 dx = 0: dy = 0
                 if ((nZoomWidth < lpr.nRight) or (nZoomHeight < lpr.nBottom)) then
                     rThumbRatio = gP.thumb_xS / nZoomWidth
                     if (nZoomWidth < lpr.nRight) then dx = ((lpr.nRight - nZoomWidth) \ 2) * rThumbRatio
                     if (nZoomHeight < lpr.nBottom) then dy = ((lpr.nBottom - nZoomHeight) \ 2) * rThumbRatio
                 end if
                 if (x < gP.thumb_xP - dx) then
                     x = gP.thumb_xP - dx
                 elseif (x > gP.thumb_xP + gP.thumb_xS - w + dx) then
                     x = gP.thumb_xP + gP.thumb_xS - w + dx
                 end if
                 if (y < gP.thumb_yP - dy) then
                     y = gP.thumb_yP - dy
                 elseif (y > gP.thumb_yP + gP.thumb_yS - h + dy) then
                     y = gP.thumb_yP + gP.thumb_yS - h + dy
                 end if
                 '// Retrieve the previous coordinates
                 ZD_GetObjectXY(nID, nX, nY)
                 nX = x - nX: nY = y - nY
                 if ((nX) or (NY)) then
                     sif.cbSize = sizeof(sif)
                     sif.fMask  = %SIF_ALL
                     if (nX) then
                         GetScrollInfo(gP.hCtrl, %SB_HORZ, sif)
                         sif.nPos += nX * rRatio
                         SetScrollInfo(gP.hCtrl, %SB_HORZ, sif, %TRUE)
                         SendMessage(gP.hCtrl, %WM_HSCROLL, mak(long, %SB_HORZ, 0), 0)
                     end if
                     if (nY) then
                         GetScrollInfo(gP.hCtrl, %SB_VERT, sif)
                         sif.nPos += nY * rRatio
                         SetScrollInfo(gP.hCtrl, %SB_VERT, sif, %TRUE)
                         SendMessage(gP.hCtrl, %WM_VSCROLL, mak(long, %SB_VERT, 0), 0)
                     end if
                 end if
                 '// Apply new coordinates
                 ZD_SetObjectXY(nID, x, y, 0)
                 GDImageDrawThumbRect()
                 nRet = 1

             end if

        case %WM_KEYDOWN
             '// Check if keyboard accelerator keys are yeld down
             if (ZI_IsCtrlKeyPressed()) then
                 UseStep = 4
                 if (ZI_IsShiftKeyPressed()) then UseStep = 16
             elseif (ZI_IsShiftKeyPressed()) then
                 UseStep = 2
             else
                 UseStep = 1
             end if
             ZD_GetObjectXY(nID, x, y)
             '// Get the sprite size
             ZD_GetObjectBound(nID, w, h)

             select case long wParam
             case %VK_HOME, %VK_NUMPAD7
                  x = gP.thumb_xP
             case %VK_END, %VK_NUMPAD1
                  x = gP.thumb_xP + gP.thumb_xS - w
             case %VK_PRIOR, %VK_NUMPAD9
                  y = gP.thumb_yP
             case %VK_NEXT, %VK_NUMPAD3
                  y = gP.thumb_yP + gP.thumb_yS - h
             case %VK_LEFT, %VK_NUMPAD4
                  x -= UseStep
             case %VK_UP, %VK_NUMPAD8
                  y -= UseStep
             case %VK_RIGHT, %VK_NUMPAD6
                  x += UseStep
             case %VK_DOWN, %VK_NUMPAD2
                  y += UseStep
             end select
             '// Adjust the coordinates to stay inside of the zoomed image bounds
             nZoomWidth = nW * rZoomValue: nZoomHeight = nH * rZoomValue
             dx = 0: dy = 0
             if ((nZoomWidth < lpr.nRight) or (nZoomHeight < lpr.nBottom)) then
                 rThumbRatio = gP.thumb_xS / nZoomWidth
                 if (nZoomWidth < lpr.nRight) then dx = ((lpr.nRight - nZoomWidth) \ 2) * rThumbRatio
                 if (nZoomHeight < lpr.nBottom) then dy = ((lpr.nBottom - nZoomHeight) \ 2) * rThumbRatio
             end if
             if (x < gP.thumb_xP - dx) then
                 x = gP.thumb_xP - dx
             elseif (x > gP.thumb_xP + gP.thumb_xS - w + dx) then
                 x = gP.thumb_xP + gP.thumb_xS - w + dx
             end if
             if (y < gP.thumb_yP - dy) then
                 y = gP.thumb_yP - dy
             elseif (y > gP.thumb_yP + gP.thumb_yS - h + dy) then
                 y = gP.thumb_yP + gP.thumb_yS - h + dy
             end if
             '// Retrieve the previous coordinates
             ZD_GetObjectXY(nID, nX, nY)
             nX = x - nX: nY = y - nY
             if ((nX) or (nY)) then
                 sif.cbSize = sizeof(sif)
                 sif.fMask  = %SIF_ALL
                 if (nX) then
                     GetScrollInfo(gP.hCtrl, %SB_HORZ, sif)
                     sif.nPos += nX * rRatio
                     SetScrollInfo(gP.hCtrl, %SB_HORZ, sif, %TRUE)
                     SendMessage(gP.hCtrl, %WM_HSCROLL, mak(long, %SB_HORZ, 0), 0)
                 end if
                 if (nY) then
                     GetScrollInfo(gP.hCtrl, %SB_VERT, sif)
                     sif.nPos += nY * rRatio
                     SetScrollInfo(gP.hCtrl, %SB_VERT, sif, %TRUE)
                     SendMessage(gP.hCtrl, %WM_VSCROLL, mak(long, %SB_VERT, 0), 0)
                 end if
             end if
             '// Apply the new coordinates
             ZD_SetObjectXY(nID, x, y, 0)
             GDImageDrawThumbRect()
             nRet = 1

        end select
    else
        select case long Msg
        case %WM_VSCROLL, %WM_HSCROLL
             GDImageDrawThumbRect()
        end select
    end if
    function = nRet

end function

function IncrID() as long
    local K, nRet, nCount as long
    nCount = max&(ubound(ga_Sprite), 0)
    if (nCount > 0) then '// Detect first for any deleted ID, then we use it instead of creating a new one
        for K = 1 to nCount
            if (ga_Sprite(K).ID = 0) then nRet = K: exit for
        next
    end if
    if (nRet = 0) then
        nRet = max&(nCount + 1, 1)
        redim preserve ga_Sprite(1 to nRet) as SpriteStruct
    end if
    function = nRet
end function

sub CloneObject(byval nID as long, byval sLabel as string, byval x as long, byval y as long, byval nID_ToClone as long)
    ZD_CloneObject(nID_ToClone, nID, x, y)
    ZD_SetObjectImageLabel(nID, (sLabel))
    ZD_SetObjectScroll(nID, %TRUE)
end sub

function DropProc(byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
    local lp as POINT, lpr as RECT
    local K, nX, nY, nW, nH, nZoomW, nZoomH, xOffset, yOffset, xCurrentScroll, yCurrentScroll, nCount, NewID, nIDtoClone, nSpriteCount as long
    local hBitmap as DWORD
    local rZoomValue as single
    local sLabel, sDropName as string

    select case uMsg
    case %WM_KEYDOWN
         if (wParam = %VK_ESCAPE) then DestroyWindow(hWnd)
    case %WM_CAPTURECHANGED
         if ((ZI_IsLButtonDown() = 0) and (gP.FocusSpriteID)) then
             GetCursorPos(lp)
             ScreenToClient(gP.hCtrl, lp)
             GetClientRect(gP.hCtrl, lpr)
             if (PtInRect(lpr, lp)) then
                 '// CODE USED to COMPUTE THE CORRECT DROP LOCATION
                 '// Get current Zoom value
                 rZoomValue = ZI_GetZoomValue(gP.hCtrl)
                 '// Retrieve the size of the memory bitmap
                 ZI_GetImageSizeFromControl(gP.hCtrl, nW, nH)
                 '// Compute x,y offset
                 nZoomW = nW * rZoomValue
                 nZoomH = nH * rZoomValue
                 xOffset = 0: yOffset = 0
                 if (nZoomW < lpr.nRight or nZoomH < lpr.nBottom) then
                     if (nZoomW < lpr.nRight) then xOffset = clng((lpr.nRight - nZoomW) * 0.5)
                     if (nZoomH < lpr.nBottom) then yOffset = clng((lpr.nBottom - nZoomH) * 0.5)
                 end if
                 '// Retrieve scroll values
                 xCurrentScroll = ZI_GetXscroll(gP.hCtrl)
                 yCurrentScroll = ZI_GetYscroll(gP.hCtrl)
                 '// Assign the new sprite object.
                 sLabel = pathname$(NAME, gP.szdropname)
                 hBitmap = ZI_CreateBitmapFromFile(gP.szdropname, nW, nH)
                 '// Now we can compute the correct coordinates for the dropped sprite
                 nCount = nW \ nH: if ((nCount * nH) <> nW) then nCount = 1 else nW = nH
                 nX = clng((lp.x + xCurrentScroll - xOffset) / rZoomValue) - clng(nW * 0.5)
                 nY = clng((lp.y + yCurrentScroll - yOffset) / rZoomValue) - clng(nH * 0.5)
                 if (hBitmap) then
                     NewID = IncrID()                     '// Increment ID and ga_Sprite array
                     '// In order to save memory, we detect if we have used already the same sprite
                     nIDtoClone = 0
                     nSpriteCount = ubound(ga_Sprite) - 1
                     sDropName = lcase$(gP.szdropname)
                     for K = 1 to nSpriteCount
                         if (ga_Sprite(K).filename = sDropName) and (ga_Sprite(K).clone = 0) and (ga_Sprite(K).ID) then '// We found one
                             nIDtoClone = ga_Sprite(K).ID: exit for
                         end if
                     next
                     if (nIDtoClone) then   '// Get rid of the bitmap to save memory, and clone nIDtoClone.
                         DeleteObject(hBitmap)
                         CloneObject(NewID, "", nX, nY, nIDtoClone)
                         '// Comme c'est un clone, il faut rinitialiser les proprits de l'objet GDImage.
                         ZD_SetObjectRotation(NewID, 0)
                         ZD_SetObjectFlipMode(NewID, 0)
                         ZD_SetObjectAngle(NewID, 0, 0)
                         ZD_SetObjectScale(NewID, 0)
                         ZD_SetObjectAlpha(NewID, 255, %FALSE)
                         ZD_SetObjectFlipMode(NewID, ZD_GetObjectFlipMode(NewID))
                         ZD_SetObjectVisibility(NewID, %ZS_VISIBLE)
                     else                 '// We must use this bitmap.
                         ZD_DrawBitmapToCtrl(gP.hCtrl, nX, nY, hBitmap, ZD_ColorARGB(255, 0), NewID, %ZS_VISIBLE)
                     end if
                     ZD_SetObjectImageLabel(NewID, (sLabel))
                     if (nCount > 1) then
                         ZD_SetObjectFrameCount(NewID, nCount) '// <---- Sprite multi-state.
                         ZD_SetObjectFrameToUse(NewID, 1, %FALSE)
                     end if
                     ZD_SetObjectScroll(NewID, %TRUE)
                     ZD_SetObjectQuality(NewID, gP.UseQuality, %FALSE)
                     SpriteArrayInit(NewID, gP.szdropname)     '// Initialize the global Sprite array
                     ZI_UpdateWindow(gP.hCtrl, %FALSE)         '// Show new sprite
                     ShowSaveButton()
                 end if
             end if
             DestroyWindow(hWnd)
         end if

    case %WM_NCHITTEST
         function = %HTCAPTION: exit function
    case %WM_DESTROY
         PostQuitMessage(0)
         function = 0: exit function
    end select
    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

sub SetDropImage(byval hWnd as DWORD, szFileName as asciiz, byval nAlpha as long)
    local nImgW, nImgH, nOrientation, nCount as long
    local nGraphics, hMemDC, nDesktopDC, hBmp, Img, nImgAttr as DWORD
    local rw as RECT
    local bf as BLENDFUNCTION
    local lp, ptSrc as POINT
    local lpSize as SIZEL
    GetWindowRect(hWnd, rw)
    lpSize.cx = rw.nRight - rw.nLeft: lpSize.cy = rw.nBottom - rw.nTop
    GetCursorPos(lp)
    lp.x -= lpSize.cx * 0.5
    lp.y -= lpSize.cy * 0.5

    Img = zLoadImageFromFile(szFileName, nImgW, nImgH, nOrientation)
    if (Img) then
        nDesktopDC = GetDC(0)
        hMemDC = CreateCompatibleDC(nDesktopDC)
        hBmp = CreateCompatibleBitmap(nDesktopDC, nImgW, nImgH)
        nCount = nImgW \ nImgH: IF ((nCount * nImgH) = nImgW) then nImgW = nImgH
        SelectObject(hMemDC, hBmp)
        if (GdipCreateFromHDC(hMemDC, nGraphics) = 0) then
            GdipSetInterpolationMode(nGraphics, %InterpolationModeHighQualityBicubic)
            GdipDrawImageRectRectI(nGraphics, Img, 0, 0, lpSize.cx, lpSize.cy, 0, 0, nImgW, nImgH, 2, nImgAttr, 0, 0)
            GdipDeleteGraphics(nGraphics)
            GdipDisposeImage(Img)
        end if

        bf.BlendOp             = %AC_SRC_OVER
        bf.BlendFlags          = 0
        bf.AlphaFormat         = %AC_SRC_ALPHA '// Use source alpha
        bf.SourceConstantAlpha = nAlpha

        UpdateLayeredWindow(hWnd, nDesktopDC, lp, lpSize, hMemDC, ptSrc, 0, bf, %ULW_ALPHA)

    end if

    DeleteObject(hBmp)
    DeleteDC(hMemDC)
    ReleaseDC(0, nDesktopDC)
end sub

sub PutFocusOn(byval nObjectHandle as DWORD, byval nParam as long)
    PostMessage(nObjectHandle, %WM_LBUTTONDOWN, 0, nParam)
    PostMessage(nObjectHandle, %WM_LBUTTONUP, 0, nParam)
end sub

function CreateDropImage(szDropName as asciiz, byval w as long, byval h as long, byval nAlpha as long) as long
    local x, y, nRet, nID, IsInitialized as long
    local hDrop as DWORD
    local Msg as tagMsg
    local wcx as WndClassEx
    local zClass as asciiz * 16
    local lp as POINT
    zClass = "ZDRAGDROP"

    wcx.cbSize = sizeof(wcx)
    IsInitialized = GetClassInfoEx(gP.hInstance, zClass, wcx)
    if (IsInitialized = 0) then
        wcx.style         = %CS_HREDRAW or %CS_VREDRAW
        wcx.lpfnWndProc   = codeptr(DropProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = gP.hInstance
        wcx.hIcon         = %NULL
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %NULL
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = varptr(zClass)
        wcx.hIconSm       = %NULL
        if (RegisterClassEx(wcx)) THEN IsInitialized = -1
    end if

    if (IsInitialized) then
        GetCursorPos(lp)
        x = lp.x - w * 0.5: y = lp.y - h * 0.5

        hDrop = CreateWindowEx(%WS_EX_LAYERED, zClass, "", %WS_POPUP or %WS_VISIBLE, _
                               x, y, w, h, gP.hMain, 0, gP.hInstance, byval %NULL)
        if (hDrop) THEN
            SetDropImage(hDrop, szDropName, nAlpha)
            PostMessage(hDrop, %WM_NCLBUTTONDOWN, %HTCAPTION, mak(long, y, x))
            while GetMessage(Msg, %NULL, 0, 0)
                TranslateMessage(Msg)
                DispatchMessage(Msg)
            wend
            nRet = Msg.wParam
            gP.FocusSpriteID = 0

            '// Put focus on the new sprite that has been dropped
            GetCursorPos(lp): ScreenToClient(gP.hCtrl, lp)
            PutFocusOn(gP.hCtrl, mak(long, lp.y, lp.x))

        end if

    end if
    function = nRet
end function

function CallBack_Sprite(byval hWnd as long, byval Msg as long, byval wParam as DWORD, byval lParam as long) as long
    local nRet, nAlpha, nObjectID, nCount, ObjectType, nW, nH as long
    local sLabelName as string
    local rZoomValue as single

    static sWasSpriteLabel as string, nWasID as long

    nObjectID = ZI_MouseOverObjectID()

    select case long Msg
    case %WM_LBUTTONDOWN
         if (nObjectID) then
             if (nObjectID < %ID_BOTTOM_ARROW) then
                 ObjectType = ZD_GetObjectType(nObjectID)
                 if (ObjectType = %OBJECT_BITMAP) or (ObjectType = %OBJECT_TEXTBITMAP) then
                     if (gP.FocusSpriteID <> nObjectID) then

                         ListSelectPlus(GetDlgItem(gP.hMain, %IDC_MAP_LIST), nObjectID)
                         gP.FocusSpriteID = nObjectID

                         '// Drag and Drop
                         nAlpha = 192 '// Niveau de transparence
                         gP.szdropname = SpriteList(%ID_FirstSprite - nObjectID + 1)
                         '// Rcupre le niveau de zoom
                         rZoomValue = ZI_GetZoomValue(gP.hCtrl)
                         ZI_GetImageSizeFromFile(gP.szdropname, nW, nH)
                         nCount = nW \ nH: if ((nCount *  nH) = nW) then nW = nH
                         nW = clng(nW * rZoomValue): nH = clng(nH * rZoomValue)
                         CreateDropImage(gP.szdropname, nW, nH, nAlpha)

                     end if
                 end if
             else
                 if (nObjectID = %ID_TOP_ARROW) then
                     if (gP.nSpriteMove = 0) then
                         Ctrl_IconToBottom()
                     end if
                 elseif (nObjectID = %ID_BOTTOM_ARROW) then
                     if (gP.nSpriteMove = 0) then
                         Ctrl_IconToTop()
                     end if
                 end if
             end if
         end if
    case %WM_MOUSEMOVE
         if (nObjectID < %ID_BOTTOM_ARROW) then
             if (nWasID <> nObjectID) then
                 nWasID = nObjectID

                 '// Tooltip hover image
                 sLabelName = ZD_GetObjectImageLabel(nObjectID)
                 '// Tooltip hover image
                 if sLabelName <> sWasSpriteLabel then
                     SetWindowText(GetDlgItem(gP.hSpriteParent, %IDC_SPRITECAPTION), (sLabelName))
                     ZI_SetToolTipText(gP.hSprite, (sLabelName))
                 end if
                 sWasSpriteLabel = sLabelName

             end if
         else
             '// Clear the tooltip
             sWasSpriteLabel = "": ZI_SetToolTipText(gP.hSprite, (sWasSpriteLabel))

             nWasID = 0
             if (nObjectID = %ID_TOP_ARROW) then
                 if (gP.nSpriteArrow = 0) then
                     gP.nSpriteArrow = -1
                     Ctrl_IconTopBottom(1)
                 end if
             elseif (nObjectID = %ID_BOTTOM_ARROW) then
                 if (gP.nSpriteArrow = 0) then
                     gP.nSpriteArrow = -1
                     Ctrl_IconTopBottom(-1)
                 end if
             end if
         end if
    end select

    hWnd = 0: wParam =0: lParam = 0
    function = nRet
end function

function GDImageCallBack(byval hWnd as long, byval Msg as long, byval wParam as DWORD, byval lParam as long) as long
    local nCtrlID, nRet as long, lp as POINT

    GetCursorPos(lp): nCtrlID = GetDlgCtrlID(WindowFromPoint(lp))

    '// Dispatch message to the proper control callback
    if (nCtrlID = %IDC_CTRL) then
        nRet = CallBack_Ctrl(hWnd, Msg, wParam, lParam)
    elseif (nCtrlID = %IDC_CONTACT) then
        nRet = CallBack_Contact(hWnd, Msg, wParam, lParam)
    elseif (nCtrlID = %IDC_SPRITE) then
        nRet = CallBack_Sprite(hWnd, Msg, wParam, lParam)
    else
        nRet = CallBack_Thumb(hWnd, Msg, wParam, lParam)
    end if

    function = nRet

end function

function CheckWindowExStyle(byval hWnd as long, byval nStyle as long) as long
    if (GetWindowLong(hWnd, %GWL_EXSTYLE) and nStyle) = nStyle then function = -1
end function

function zGetCTLText(byval hCtrl as long) as string
    local szText as asciiz * 4096, Length as long
    Length = GetWindowText(hCtrl, szText, sizeof(szText))
    if (Length) then function = left$(szText, Length)
end function

sub DisplayMouseXY(byval hWnd as long, byval x as long, byval y as long)
    local rZoomValue as single
    local zTxt as asciiz * 16
    local lpr as RECT
    local nW, nH, ZoomW, ZoomH, xOffset, yOffset, xCurrentScroll, yCurrentScroll as long

    '// Get current Zoom value
    rZoomValue = ZI_GetZoomValue(hWnd)
    '// Retrieve the size of the memory bitmap
    ZI_GetImageSizeFromControl(hWnd, nW, nH)
    '// Get the client size of the control
    GetClientRect(hWnd, lpr)
    '// Compute x,y offset
    ZoomW = nW * rZoomValue
    ZoomH = nH * rZoomValue
    xOffset = 0: yOffset = 0
    if ((ZoomW < lpr.nRight) or (ZoomH < lpr.nBottom)) then
        if (ZoomW < lpr.nRight) then xOffset = (lpr.nRight - ZoomW) \ 2
        if (ZoomH < lpr.nBottom) then yOffset = (lpr.nBottom - ZoomH) \ 2
    end if
    '// Retrieve scroll values
    xCurrentScroll = ZI_GetXscroll(hWnd)
    yCurrentScroll = ZI_GetYscroll(hWnd)
    '// Show mouse coordinates
    SetWindowText(GetDlgItem(gP.hPannel, %IDC_COORD_X), str$(CLNG((x + xCurrentScroll - xOffset) / rZoomValue)) + " ")
    SetWindowText(GetDlgItem(gP.hPannel, %IDC_COORD_Y), str$(CLNG((y + yCurrentScroll - yOffset) / rZoomValue)))
end sub

sub GDImageThumbMoved()
    '// This procedure is called to update the global gP.thumb_Xpos and gP.thumb_Ypos
    '// once the Thumb window has been moved.
    local lpr, rc as RECT
    GetWindowRect(gP.hThumbParent, lpr)
    GetWindowRect(gP.hCtrl, rc)
    gP.thumb_Xpos = lpr.nLeft - rc.nLeft
    gP.thumb_Ypos = lpr.nTop - rc.nTop
end sub

sub MoveThumb()
    local lpr, rc as RECT

    GetWindowRect(gP.hThumbParent, lpr)
    GetWindowRect(gP.hCtrl, rc)

    MoveWindow(gP.hThumbParent, rc.nLeft + gP.thumb_Xpos, max&(rc.nTop + gP.thumb_Ypos, rc.nTop), _
               lpr.nRight - lpr.nLeft, lpr.nBottom - lpr.nTop, 1)
end sub

sub MoveWindows()
    local lpr, rc as RECT

    GetWindowRect(gP.hThumbParent, lpr)
    GetWindowRect(gP.hCtrl, rc)

    MoveWindow(gP.hThumbParent, rc.nLeft + gP.thumb_Xpos, max&(rc.nTop + gP.thumb_Ypos, rc.nTop), _
               lpr.nRight - lpr.nLeft, lpr.nBottom - lpr.nTop, 1)

    GetWindowRect(gP.hMain, lpr)
    MoveWindow(gP.hSpriteParent, lpr.nRight, lpr.nTop, 100, lpr.nBottom - lpr.nTop, 1)
end sub

function CreateControl(byval dwStyleEx as DWORD, _
                       zClass as asciiz, zCaption as asciiz, byval dwStyle as DWORD, _
                       byval x as long, byval y as long, byval w as long, byval h as long, _
                       byval nParent as DWORD, byval nID as long, byval nInstance as DWORD, _
                       byval Anchor as long) as DWORD
    local hCtrl as DWORD
    hCtrl = CreateWindowEx(dwStyleEx, zClass, zCaption, dwStyle, x, y, w, h, nParent, nID, nInstance, byval %NULL)
    if (hCtrl) then
        SendMessage(hCtrl, %WM_SETFONT, GetStockObject(%ANSI_VAR_FONT), 0)
        if (Anchor) then ZI_SetAnchorMode(hCtrl, Anchor)
    end if
    function = hCtrl
end function

function CaptionFont() as long
    local LF as LogFont, hDC as DWORD
    static hFont as long
    if (hFont = 0) then
        hDC = GetDC(0)
        LF.lfHeight = -MulDiv(10, GetDeviceCaps(hDC, %LOGPIXELSY), 72)
        ReleaseDC(0, hDC)
        LF.lfWidth = 0
        LF.lfCharSet = %DEFAULT_CHARSET
        LF.lfOutPrecision = %OUT_DEFAULT_PRECIS
        LF.lfClipPrecision = %OUT_DEFAULT_PRECIS
        LF.lfQuality = %DEFAULT_QUALITY
        LF.lfPitchAndFamily = %DEFAULT_PITCH OR %FF_DONTCARE
        LF.lfWeight = 700
        LF.lfFaceName = "MS Sans Serif"
        hFont = CreateFontIndirect(LF)
    end if
    function = hFont
end function

sub SetCTLFont(byval hCtrl as DWORD, byval hFont as long)
    SendMessage(hCtrl, %WM_SETFONT, hFont, 0)
end sub

function CreateStaticControl(byval dwStyle as DWORD, byval x as long, byval y as long, byval w as long, byval h as long, byval nID as long) as DWORD
    local hCtrl as DWORD
    CreateControl(0, "static", "", %WS_CHILD or %WS_VISIBLE or %WS_BORDER, x, y, w, h, gP.hPannel, 0, gP.hInstance, 0)
    hCtrl = CreateControl(0, "static", "", dwStyle, x + 1, y + 3, w - 2, h - 4, gP.hPannel, nID, gP.hInstance, 0)
    function = hCtrl
end function

function RichLoad_Callback(byval dwCookie as DWORD, byval pbbuff as byte ptr, byval cb as long, byref pcb as long) as long
    local psBuffer as string ptr
    psBuffer = dwCookie
    pcb = min&(len(@psBuffer), cb)
    if (pcb > 0) then
        POKE$ pbBuff, left$(@psBuffer, pcb)
        @psBuffer = mid$(@psBuffer, pcb + 1)
    end if
end function

sub LoadRTF()
    local es as EDITSTREAM
    local BufferSize, fHandle, ByttesReaded as DWORD
    local zFileName as asciiz * %MAX_PATH
    local sBuffer as string
    zFileName = EXEresource() + GoodMsg("HELP_fr.rtf","HELP_us.rtf")
    if (zExist(zFileName)) then
        BufferSize = FileSize(zFileName)
        sBuffer = space$(BufferSize)
        if (zFOpen(zFileName, 0, 2, fHandle) = 0) then
            ReadFile(fHandle, byval strptr(sBuffer), BufferSize, ByttesReaded, byval %NULL)
            zFClose(fHandle): fHandle = 0
            es.dwCookie = varptr(sBuffer)
            es.pfnCallback = codeptr(RichLoad_Callback)
            SendMessage(gP.hHelp, %EM_STREAMIN, %SF_RTF, varptr(es))
        end if
    end IF
end sub

sub CreateChildControls(zClass as asciiz)
    local dwStyle, dwStyleEx, hCtrl as DWORD
    local rc as RECT
    local x, y, w, h as long

    gP.hRemoveFocus = CreateControl(0, "BUTTON", "", %WS_CHILD, 0, 0, 0, 0, gP.hMain, 0, gP.hInstance, 0)

    '// =============================================================================
    '// CONTACT SHEET control
    dwStyle = %WS_CHILD or %WS_VISIBLE
    gP.hContact = CreateControl(0, $GDImageClassName, "", dwStyle, 0, 0, %CLIENT_WIDTH, 128, gP.hMain, %IDC_CONTACT, gP.hInstance, 0)
    if (gP.hContact) then
        '// Gradiant color to paint the background
        ZI_SetProperty(gP.hContact, %ZI_GradientTop, %COLORGRAY)
        ZI_SetProperty(gP.hContact, %ZI_GradientBottom, %COLORGRAY)
        '// Add tooltip support to the GDImage contact sheet.
        ZI_CreateToolTip(gP.hContact, "")
    end if

    '// =============================================================================
    '// TOP SPLITTER control
    skPushButtonImage(gP.hMain, EXEresource() + "splith.png", "", -4, 128, %CLIENT_WIDTH + 8, 8, %IDC_SPLIT_TOP, 0)

    '// =============================================================================
    '// MAIN ZOOMPLUS GRAPHIC control
    dwStyle = %WS_CHILD or %WS_VISIBLE or %WS_HSCROLL or %WS_VSCROLL      or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN 
    gP.hCtrl = CreateControl(0, $GDImageClassName, "", dwStyle, 0, 128 + 8, %CLIENT_WIDTH, 579, gP.hMain, %IDC_CTRL, gP.hInstance, 0)
    if (gP.hCtrl) then
        '// Setup FontBox default parameters 800x800, 128 pixels, 64 characters
        ZI_SetFontBoxParameters(800, 128, 64)

        '// Don't forget to let it be a ZOOM window !
        ZI_SetProperty(gP.hCtrl, %ZI_ZoomWindow, %TRUE)
        '// Gradiant color to paint the background
        ZI_SetProperty(gP.hCtrl, %ZI_GradientTop, %COLORGRAY)
        ZI_SetProperty(gP.hCtrl, %ZI_GradientBottom, %COLORGRAY)
        '// Add tooltip support to the main GDImage control
        ZI_CreateToolTip(gP.hCtrl, "")
    end if

    '// =============================================================================
    '// THUMBNAIL POPUP control
    GetWindowRect(gP.hCtrl, rc)
    dwStyle = %WS_POPUP or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN or %WS_BORDER
    dwStyleEx = %WS_EX_TOOLWINDOW
    gP.hThumbParent = CreateControl(dwStyleEx, zClass, "", dwStyle, rc.nLeft, rc.nTop, 174, 215, gP.hMain, 0, gP.hInstance, 0)

    '// -----------------------------------------------------------------------------
    '// THUMBNAIL CAPTION control
    dwStyle = %WS_CHILD or %WS_VISIBLE or %SS_CENTER
    hCtrl = CreateControl(0, "static", "", dwStyle, 0, 3, 174, 17, gP.hThumbParent, %IDC_THUMBCAPTION, gP.hInstance, 0)
    SetCTLFont(hCtrl, CaptionFont())

    '// -----------------------------------------------------------------------------
    '// THUMBNAIL GRAPHIC control
    dwStyle = %WS_CHILD or %WS_VISIBLE or %WS_BORDER
    gP.hThumb = CreateControl(0, $GDImageClassName, "", dwStyle, 1, 22, 170, 160, gP.hThumbParent, %IDC_THUMB, gP.hInstance, 0)
    '// This is a fit to window control
    if (gP.hThumb) then
        ZI_SetProperty(gP.hThumb, %ZI_GradientTop, %COLORGRAY)
        ZI_SetProperty(gP.hThumb, %ZI_GradientBottom, %COLORGRAY)
        ZI_SetProperty(gP.hThumb, %ZI_FitToWindow, 1)
    end if

    '// -----------------------------------------------------------------------------
    '// THUMBNAIL ZOOM SLIDER control
    dwStyle = %WS_CHILD or %WS_VISIBLE or %TBS_BOTH or %TBS_NOTICKS
    hCtrl = CreateControl(0, "msctls_trackbar32", "", dwStyle, 1, 185, 170, 27, gP.hThumbParent, %IDC_ZOOM, gP.hInstance, 0)
    gP.zoomMin = 194
    gP.zoomMax = 1020
    SendMessage(hCtrl, %TBM_SETRANGE, %TRUE, mak(long, gP.zoomMin, gP.zoomMax))
    SendMessage(hCtrl, %TBM_SETPAGESIZE, 0, 5)
    '// Setup zoom default
    SendMessage(hCtrl, %TBM_SETPOS, %TRUE, 195)

    '// =============================================================================
    '// SPRITE ICON POPUP control
    GetWindowRect(gP.hMain, rc)
    dwStyle = %WS_POPUP or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN or %WS_BORDER
    dwStyleEx = %WS_EX_TOOLWINDOW
    gP.hSpriteParent = CreateControl(dwStyleEx, zClass, "", dwStyle, rc.nRight, rc.nTop, 100, rc.nBottom - rc.nTop, gP.hMain, 0, gP.hInstance, 0)

    '// -----------------------------------------------------------------------------
    '// SPRITE ICON CAPTION control
    dwStyle = %WS_CHILD or %WS_VISIBLE or %SS_CENTER
    hCtrl = CreateControl(0, "static", "", dwStyle, 0, 3, 98, 20, gP.hSpriteParent, %IDC_SPRITECAPTION, gP.hInstance, 0)
    SetCTLFont(hCtrl, CaptionFont())

    '// -----------------------------------------------------------------------------
    '// SPRITE ICON GRAPHIC control
    dwStyle = %WS_CHILD or %WS_VISIBLE or %WS_BORDER
    gP.hSprite = CreateControl(0, $GDImageClassName, "", dwStyle, 1, 24, 96, rc.nBottom - rc.nTop - 27, gP.hSpriteParent, %IDC_SPRITE, gP.hInstance, 0)
    if (gP.hSprite) then
        ZI_SetProperty(gP.hSprite, %ZI_GradientTop, %COLORGRAY)
        ZI_SetProperty(gP.hSprite, %ZI_GradientBottom, %COLORGRAY)
        ZI_CreateToolTip(gP.hSprite, "") '// Add tooltip support to the GDImage sprite sheet.
    end if

    '// =============================================================================
    '// BOTTOM SPLITTER control
    skPushButtonImage(gP.hMain, EXEresource() + "splith.png", "", -4, 715, %CLIENT_WIDTH + 8, 8, %IDC_SPLIT_BOTTOM, 0)

    '// =============================================================================
    '// BOTTOM PANEL control
    dwStyle = %WS_CHILD or %WS_VISIBLE 'or %WS_CLIPCHILDREN
    gP.hPannel = CreateControl(0, zClass, "", dwStyle, 0, 723, %CLIENT_WIDTH, %CLIENT_HEIGHT - 723, gP.hMain, %IDC_PANNEL, gP.hInstance, 0)

    '// -----------------------------------------------------------------------------
    '// Mouse coordinates
    dwStyle = %WS_CHILD or %WS_VISIBLE
    CreateControl(0, "static", "X.Y", dwStyle, 4, 15, 20, 16, gP.hPannel, 0, gP.hInstance, 0)
    CreateStaticControl(dwStyle or %SS_RIGHT, 24, 12, 44, 20, %IDC_COORD_X)
    CreateStaticControl(dwStyle, 69, 12, 44, 20, %IDC_COORD_Y)

    '// -----------------------------------------------------------------------------
    '// Sprite ID and LABEL
    dwStyle = %WS_CHILD or %WS_VISIBLE
    CreateControl(0, "static", "ID", dwStyle, 126, 15, 14, 16, gP.hPannel, 0, gP.hInstance, 0)
    x = 140: y = 12: w = 44: h = 20
    CreateControl(0, "static", "", %WS_CHILD or %WS_VISIBLE or %WS_BORDER, x, y, w, h, gP.hPannel, 0, gP.hInstance, 0)
    hCtrl = CreateControl(0, "static", "", dwStyle, x + 1, y + 1, w - 2, h - 4, gP.hPannel, %IDC_ID, gP.hInstance, 0)
    SetCTLFont(hCtrl, CaptionFont())
    dwStyle = %WS_CHILD or %WS_VISIBLE or %WS_BORDER or %ES_AUTOHSCROLL or %WS_DISABLED
    hCtrl = CreateControl(0, "EDIT", "", dwStyle, 185, 12, 300, 20, gP.hPannel, %IDC_LABEL, gP.hInstance, 0)
    SetCTLFont(hCtrl, CaptionFont())

    '// -----------------------------------------------------------------------------
    '// Sprite coordinates
    dwStyle = %WS_CHILD or %WS_VISIBLE
    CreateControl(0, "static", "X.Y", dwStyle, 488, 15, 20, 16, gP.hPannel, 0, gP.hInstance, %ANCHOR_BOTTOM)
    x = 508: y = 12: w = 48: h = 20
    CreateControl(0, "static", "", %WS_CHILD or %WS_VISIBLE or %WS_BORDER, x, y, w, h, gP.hPannel, 0, gP.hInstance, 0)
    hCtrl = CreateControl(0, "static", "", dwStyle or %SS_RIGHT, x + 1, y + 1, w - 2, h - 4, gP.hPannel, %IDC_ID_COORD_X, gP.hInstance, 0)
    SetCTLFont(hCtrl, CaptionFont())
    x = 557: y = 12: w = 48: h = 20
    CreateControl(0, "static", "", %WS_CHILD or %WS_VISIBLE or %WS_BORDER, x, y, w, h, gP.hPannel, 0, gP.hInstance, 0)
    hCtrl = CreateControl(0, "static", "", dwStyle, x + 1, y + 1, w - 2, h - 4, gP.hPannel, %IDC_ID_COORD_Y, gP.hInstance, 0)
    SetCTLFont(hCtrl, CaptionFont())

    SetCTLFont(hCtrl, CaptionFont())

    '// -----------------------------------------------------------------------------
    '// Open button
    hCtrl = skPushButtonImage(gP.hPannel, EXEresource() + "folder.png", "", 612, 2, 40, 40, %IDC_OPEN, 0)
    skCreateToolTip(hCtrl, GoodMsg("Selectionne un projet de la planche contact", "Select a project from the contact sheet"))

    '// -----------------------------------------------------------------------------
    '// Print button
    hCtrl = skPushButtonImage(gP.hPannel, EXEresource() + "print.png", "", 652, 2, 40, 40, %IDC_PRINT, 0)
    skCreateToolTip(hCtrl, GoodMsg("Imprime une image du projet", "Print a project image"))

    '// -----------------------------------------------------------------------------
    '// Save image button
    hCtrl = skPushButtonImage(gP.hPannel, EXEresource() + "image.png", "", 692, 2, 40, 40, %IDC_SAVEIMAGE, 0)
    skCreateToolTip(hCtrl, GoodMsg("Cre une image du projet", "Create a project image"))

    '// -----------------------------------------------------------------------------
    '// Crop button
    hCtrl = skPushButtonImage(gP.hPannel, EXEresource() + "cut.png", "", 732, 2, 40, 40, %IDC_CROP, 0)
    skCreateToolTip(hCtrl, GoodMsg("Delimite une section rectangulaire", "Crop a rectangular section"))

    '// -----------------------------------------------------------------------------
    '// Lock sprite button
    hCtrl = skPushButtonImage(gP.hPannel, EXEresource() + "locksprite.png", "", 772, 2, 40, 40, %IDC_LOCKSPRITE, 0)
    skCreateToolTip(hCtrl, GoodMsg("Verrouille tous les objets", "Lock all the objects"))

    '// -----------------------------------------------------------------------------
    '// Script save button
    hCtrl = skPushButtonImage(gP.hPannel, EXEresource() + "save.png", GoodMsg("      Sauve projet","      Save project"), 812, 2, 140, 40, %IDC_SCRIPTSAVE, %BS_CENTER or %BS_VCENTER)
    ShowWindow(hCtrl, %SW_HIDE)
    skSetLabelFont(hCtrl, EXEresource() + "ft01.ttf", 18, skARGB(255, 255,255,255), %FontStyleRegular)
    skCreateToolTip(hCtrl, GoodMsg("Enregistre le projet", "Save the project"))

    '// -----------------------------------------------------------------------------
    '// User help button
    hCtrl = skButtonImage(gP.hPannel, EXEresource() + "BTN_Help.png", 957, 7, %IDC_USERHELP, 5)
    skCreateToolTip(hCtrl, GoodMsg("Aide utilisateur", "User help"))
    hCtrl = skButtonImage(gP.hPannel, EXEresource() + "BTN_Help2.png", 957, 7, %IDC_USERHELP + 1, 5)
    ShowWindow(hCtrl, %SW_HIDE)

    '// -----------------------------------------------------------------------------
    '// Close button
    hCtrl = skButtonImage(gP.hPannel, EXEresource() + "BTN_Close.png", 989, 7, %IDC_CLOSE, 5)
    skCreateToolTip(hCtrl, GoodMsg("Fermer", "Close"))


    dwStyle = %WS_CHILD or %WS_VSCROLL or %ES_MULTILINE or %ES_READONLY or %WS_BORDER
    gP.hHelp = CreateWindowEx(0, "RichEdit20A", "", dwStyle, 0, 0, 0, 0, gP.hCtrl, %IDC_RICHEDIT, gP.hInstance, byval %NULL)
    if (IsWindow(gP.hHelp)) then LoadRTF()    

end sub

sub ListDeleteAll(byval hList as long)
    if (IsWindow(hList)) then SendMessage(hList, %LB_RESETCONTENT, 0, 0)
end sub

function ListAdd(byval hList as long, zTmp as asciiz) as long
    if (IsWindow(hList)) then
        if (len(zTmp)) then function = SendMessage(hList, %LB_ADDSTRING, 0, varptr(zTmp))
    end if
end function

function ListFindString(byval hList as long, zTmp as asciiz) as long
    local nIndex as long
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, varptr(zTmp))
    if (nIndex > -1) then incr nIndex: function = nIndex
end function

sub ListSelectPlus(byval hList as long, byval nSelected as long)
    if nSelected > 0 then decr nSelected '// Because ListBox is zero based
    if (IsWindow(hList)) then SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
end sub

function ListCount(byval hList as long) as long
    if (IsWindow(hList)) then function = SendMessage(hList, %LB_GETCOUNT, 0, 0)
end function

function ListGetCursel(byval hList as long) as long
    local nSelected as long
    if (IsWindow(hList)) then
        nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
        if (nSelected > -1) then incr nSelected '// Because ListBox is zero based
    end if
    function = nSelected
end function

function ListGetText(byval hList as long, byval nItem as long) as string
    local sItem as string, nLen as long
    if (nItem > 0) then
        decr nItem
        nLen = SendMessage(hList, %LB_GETTEXTLEN, nItem, 0)
        sItem = space$(nLen)
        SendMessage(hList, %LB_GETTEXT, nItem, byval STRPTR(sItem))
        function = sItem
    end if
end function

sub DetectSprite()
    local hList, WashFind, hFind as DWORD
    local nCount as long
    local fd as WIN32_FIND_DATA
    local zTmp as asciiz * %MAX_PATH

    hList = GetDlgItem(gP.hMain, %IDC_SPRITE_LIST)
    if (hList = 0) then
        hList = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD or %LBS_SORT, 0, -1000, 0, 0, _
                               gP.hMain, %IDC_SPRITE_LIST, gP.hInstance, byval %NULL)
    else
        ListDeleteAll(hList)
    end if

    WashFind = FindFirstFile(SpritePath() + "*.*", fd)
    hFind = WashFind
    do while hFind > 0
       if (asc(fd.cFileName) <> 46) then
           if (instr(chr$(0,1,32,33,128), chr$(fd.dwFileAttributes))) then
               zTmp = fd.cFileName: CharLower(zTmp)
               if (instr($IMAGE_EXT, right$(zTmp, 4) + $Dot)) then
                   if (ListAdd(hList, SpritePath() + zTmp) > -1) then
                       nCount += 1
                   end if
               end if
           end if
       end if
       hFind = FindNextFile(WashFind, fd)
    loop
    FindClose(WashFind)

    if (nCount > 0) then ListSelectPlus(hList, 1)

end sub

function SpriteList(byval nItem as long) as string
    local hList as DWORD
    hList = GetDlgItem(gP.hMain, %IDC_SPRITE_LIST)
    if (hList) then
        function = ListGetText(hList, nItem)
    end if
end function

sub DetectMap()
    local fd as WIN32_FIND_DATA
    local nCount, nItem as long
    local hList, hFind, WashFind as DWORD
    local zTmp as asciiz * %MAX_PATH
    local sPath, sUseFile as string

    hList = GetDlgItem(gP.hMain, %IDC_MAP_LIST)
    if (hList = 0) then
        hList = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD or %LBS_SORT, 0, -1000, 0, 0, _
                               gP.hMain, %IDC_MAP_LIST, gP.hInstance, byval %NULL)
    else
        ListDeleteAll(hList)
    end if

    zSplitN(gP.szproject, sPath, sUseFile)

    WashFind = FindFirstFile(EXEmap() + "*.*", fd)
    hFind = WashFind
    do while hFind > 0
       if (asc(fd.cFileName) <> 46) then
           if (instr(chr$(0,1,32,33,128), chr$(fd.dwFileAttributes))) then
               zTmp = lcase$(fd.cFileName)
               if (instr($IMAGE_EXT, right$(zTmp, 4) + $Dot)) then
                   if (left$(zTmp, 4) <> $thb) then
                       if (ListAdd(hList, EXEmap() + zTmp) > -1) then
                           nCount += 1
                           if (zTmp = sUseFile) then nItem = nCount
                       end if
                   end if
               end if
           end if
       end if
       hFind = FindNextFile(WashFind, fd)
    loop
    if (nItem) then
        ListSelectPlus(hList, nItem)
        gP.FocusContactID = %ID_FirstContact - nItem + 1
    end if
end sub

function zDisplayDC() as DWORD
    function = CreateIC ("DISPLAY", byval %NULL, byval %NULL, byval %NULL)
end function

function CreateThumb(zImageDest as asciiz, byval rwX as long, byval rwY as long, zUseBackground as asciiz) as long

    local nRet, x, y, ImgW, ImgH, Wider, LeftW, TopW, RightW, BottomW as long
    local hBitmap, hIC, hDC, graphics, Img, ImgAttr, hRgn as DWORD

    hIC = zDisplayDC()

    hBitmap = ZI_CreateDIBSection(hIC, rwX, rwY, 32)
    hDC = CreateCompatibleDC(hIC)
    SelectObject(hDC, hBitmap)

    DeleteDC(hIC)

    if (GdipCreateFromHDC(hDC, graphics) = 0) then

       '// Load the background to be paint in stretched mode
       Img = zLoadImageFromFile(zUseBackground, ImgW, ImgH, 0)
       '// Paint in stretch mode
       local xP, yP, xS, yS as long
       ZI_Iconise(ImgW, ImgH, rwX, rwY, xP, yP, xS, yS)
       '// Set up stretching QualityMode
       GdipSetInterpolationMode(graphics, 2)
       GdipDrawImageRectRectI(graphics, Img, xP, yP, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, ImgAttr, 0, 0)
       ZI_DeleteImageObject(Img)

       GdipDeleteGraphics(graphics)

       Img = zBitmapToImage(hDC)
       if (Img) then
          if zSaveImageToFile(zImageDest, Img, 0) = 0 then nRet = -1
       end if
       ZI_DeleteImageObject(Img)

       DeleteObject(hBitmap)
       DeleteDC(hDC)

    end if
    function = nRet
end function

sub CheckThumb(szMap as asciiz, szThumb as asciiz, byval nTW as long, byval nTH as long)
    if (zExist(szMap)) then
        if (not zExist(szThumb)) then
            CreateThumb(szThumb, nTW, nTH, szMap)
        else
            local nW, nH as long
            ZI_GetImageSizeFromFile(szThumb, nW, nH)
            if (nW <> nTW) or (nH <> nTH) then CreateThumb(szThumb, nTW, nTH, szMap)
        end if
    end if
end sub

sub BuildMapCtrl()
    local lpr as RECT
    local nID, nUseAlpha, K, nX, nY, nW, nH, nSizeX, nSizeY, nCountMax as long
    local szFileName as asciiz * %MAX_PATH, szThumb as asciiz * %MAX_PATH
    local hList, hBitmap as DWORD

    '// Fill up the MAP listbox and detect the active contact sprite
    DetectMap()

    hList = GetDlgItem(gP.hMain, %IDC_MAP_LIST)
    GetClientRect(gP.hContact, lpr)

    nCountMax = ListCount(hList)
    nSizeX = lpr.nBottom - 4: nSizeY = nSizeX: nX = 2: nY = 2
    nID = %ID_FirstContact
    for K = 1 to nCountMax

        szFileName = ListGetText(hList, K)
        szThumb = pathname$(PATH, szFileName) + $thb + pathname$(NAME, szFileName) + ".png"
        CheckThumb(szFileName, szThumb, nSizeX, nSizeY)

        hBitmap = ZI_FitBitmapFromFile(szThumb, nSizeX, nSizeY)
        if (nID = gP.FocusContactID) then nUseAlpha = 255 else nUseAlpha = %ALPHA_MIN
        ZD_DrawBitmapToCtrl(gP.hContact, nX, nY, hBitmap, ZD_ColorARGB(nUseAlpha, 0), nID, %ZS_HIDDEN)
        if (nID <> gP.FocusContactID) then
            ZD_SetObjectScale(nID, 0.9)
        end if
        ZD_SetObjectLocked(nID, %TRUE)
        szFileName = pathname$(NAME, szFileName): REPLACE "_" WITH " " IN szFileName
        ZD_SetObjectImageLabel(nID, szFileName)

        nX += nSizeX + 4
        nID -= 1
    next

    '// Left navigation arrow
    hBitmap = ZI_CreateBitmapFromFile(EXEresource() + "Left_arrow.png", nW, nH)
    nY += (nSizeY - nH) * 0.5
    ZD_DrawBitmapToCtrl(gP.hContact, 0, nY, hBitmap, ZD_ColorARGB(255, 0), %ID_LEFT_ARROW, %ZS_HIDDEN)
    ZD_SetObjectLocked(%ID_LEFT_ARROW, %TRUE)
    ZD_SetObjectAnchorMode(%ID_LEFT_ARROW, %ANCHOR_LEFT)

    '// Right navigation arrow
    hBitmap = ZI_CreateBitmapFromFile(EXEresource() + "Right_arrow.png", nW, nH)
    ZD_DrawBitmapToCtrl(gP.hContact, lpr.nRight - nW, nY, hBitmap, ZD_ColorARGB(255, 0), %ID_RIGHT_ARROW, %ZS_HIDDEN)
    ZD_SetObjectLocked(%ID_RIGHT_ARROW, %TRUE)
    ZD_SetObjectAnchorMode(%ID_RIGHT_ARROW, %ANCHOR_RIGHT)

    '// Show icons and navigation arrows
    ZD_GetObjectXY(1, nX, nY): if (nX < 0) then ZD_SetObjectVisibility(%ID_LEFT_ARROW, %TRUE)
    ZD_GetObjectXY(nCountMax, nX, nY): if (nX > lpr.nRight) then ZD_SetObjectVisibility(%ID_RIGHT_ARROW, %TRUE)
    nID = %ID_FirstContact
    for K = 1 to nCountMax
        ZD_SetObjectVisibility(nID, %TRUE)
        nID -= 1
    next

    Ctrl_MapShowArrow()

end sub

sub BuildIconCtrl()
    local lpr as RECT
    local K, nID, nX, nY, nW, nH, nSizeX, nSizeY, XPicSize, YPicSize, nCount, nCountMax as long
    local hBitmap, hCropBitmap, hList as DWORD
    local szFileName as asciiz * %MAX_PATH

    hList = GetDlgItem(gP.hMain, %IDC_SPRITE_LIST)

    GetClientRect(gP.hSprite, lpr)

    nCountMax = ListCount(hList)
    nSizeX = lpr.nRight - 4: nSizeY = nSizeX
    nX = 2: nY = 2
    nID = %ID_FirstSprite

    for K = 1 to nCountMax

        szFileName = ListGetText(hList, K)

        '// In case of multi-state, crop the first state before to fit it within nSizeX, nSizeY.
        hCropBitmap = ZI_CreateBitmapFromFile(szFileName, XPicSize, YPicSize)
        nCount = XPicSize \ YPicSize: if ((nCount * YPicSize) <> XPicSize) then nCount = 1
        if (nCount > 1) then
            hBitmap = ZI_CropBitmap(hCropBitmap, 0, 0, YPicSize, YPicSize, 0)
            DeleteObject(hCropBitmap)
            hCropBitmap = hBitmap: hBitmap = 0
        end if
        hBitmap = ZI_FitBitmapFromBitmap(hCropBitmap, nSizeX, nSizeY)
        DeleteObject(hCropBitmap)

        ZD_DrawBitmapToCtrl(gP.hSprite, nX, nY, hBitmap, ZD_ColorARGB(255, 0), nID, %ZS_VISIBLE)

        ZD_SetObjectLocked(nID, %TRUE)
        szFileName = pathname$(NAME, szFileName): REPLACE "_" WITH " " IN szFileName
        ZD_SetObjectImageLabel(nID, szFileName)

        nY += nSizeY + 4
        nID -= 1
    next

    '// TOP navigation arrow
    hBitmap = ZI_CreateBitmapFromFile(EXEresource() + "Top_arrow.png", nW, nH)
    nX = (lpr.nRight - nW) * 0.5
    ZD_DrawBitmapToCtrl(gP.hSprite, nX, 6, hBitmap, ZD_ColorARGB(255, 0), %ID_TOP_ARROW, %ZS_HIDDEN)
    ZD_SetObjectLocked(%ID_TOP_ARROW, %TRUE)
    ZD_SetObjectAnchorMode(%ID_TOP_ARROW, %ANCHOR_LEFT)

    '// Right navigation arrow
    hBitmap = ZI_CreateBitmapFromFile(EXEresource() + "Bottom_arrow.png", nW, nH)
    ZD_DrawBitmapToCtrl(gP.hSprite, nX, lpr.nBottom - 6 - nH, hBitmap, ZD_ColorARGB(255, 0), %ID_BOTTOM_ARROW, %ZS_HIDDEN)
    ZD_SetObjectLocked(%ID_BOTTOM_ARROW, %TRUE)
    ZD_SetObjectAnchorMode(%ID_BOTTOM_ARROW, %ANCHOR_BOTTOM)

    '// Show sprites and navigation arrows
    ZD_GetObjectXY(1, nX, nY): if nY < 0 then ZD_SetObjectVisibility(%ID_TOP_ARROW, %TRUE)
    ZD_GetObjectXY(nCountMax, nX, nY): if nY > lpr.nBottom then ZD_SetObjectVisibility(%ID_BOTTOM_ARROW, %TRUE)

    Ctrl_IconShowArrow()
end sub

sub RenderAnimation()
    if (IsWindowVisible(gP.hContact)) then
        local K, nID, nCountMax, nDone, nAlpha as long
        local rScale as single

        local lp as POINT
        GetCursorPos(lp)
        if (WindowFromPoint(lp) <> gP.hContact) then gP.nContactID = 0

        nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_MAP_LIST))
        nID = %ID_FirstContact - nCountMax + 1
        for K = nCountMax to 1 step -1
            if (nID <> gP.FocusContactID) then
                nAlpha = ZD_GetObjectAlpha(nID)
                rScale = ZD_GetObjectScale(nID)
                if (nID = gP.nContactID) then
                    if (nAlpha < 255) then
                        nDone = -1
                        nAlpha += %ALPHA_STEP
                        if (nAlpha > 255) then nAlpha = 255
                        if (rScale < 1) then
                            rScale += 0.02: if rScale > 1 then rScale = 1
                            ZD_SetObjectScale(nID, rScale)
                        end if
                        ZD_SetObjectAlpha(nID, nAlpha, %FALSE)
                    end if
                else
                    if (nAlpha > %ALPHA_MIN) then
                        nDone = -1
                        nAlpha -= %ALPHA_STEP
                        if (nAlpha < %ALPHA_MIN) then nAlpha = %ALPHA_MIN
                        if (rScale > 0.9) then
                            rScale -= 0.02: if rScale < 0.9 then rScale = 0.9
                            ZD_SetObjectScale(nID, rScale)
                        end if
                        ZD_SetObjectAlpha(nID, nAlpha, %FALSE)
                    end if
                end if
            end if
            nID += 1
        next

        if (nDone) then ZI_UpdateWindow(gP.hContact, 0)
    end if
end sub

sub Ctrl_MapLeftRight(local nLeftRight as long)
    local lpr as RECT
    local nID, K, nS, nStepX, nX, nY, nDoIt, nUseStep, nCountMax, nArrowClic as long

    GetClientRect(gP.hContact, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_MAP_LIST))
    nUseStep = 4
    if (lpr.nRight > 1024) then nUseStep = 8
    if (lpr.nRight > 1600) then nUseStep = 16
    nUseStep = nUseStep * nLeftRight

    if (nUseStep < 0) then '// Right arrow
       ZD_GetObjectXY(%ID_FirstContact - nCountMax + 1, nX, nY): if nX > lpr.nRight then nDoIt = -1
    else                 '// Left arrow
       ZD_GetObjectXY(%ID_FirstContact, nX, nY): if nX < 0 then nDoIt = -1
    end if

    if (nDoIt) then
        nStepX = ABS(nUseStep)
        if (gP.nContactMove = 0) then
            gP.nContactMove = 1
            for nS = 1 to lpr.nBottom step nStepX
                nID = %ID_FirstContact
                for K = 1 to nCountMax
                    ZD_GetObjectXY(nID, nX, nY)
                    ZD_SetObjectXY(nID, nX + nUseStep, nY, %FALSE)
                    nID -= 1
                next
                ZD_GetObjectXY(%ID_FirstContact, nX, nY): if nX < 0 then nDoIt = %TRUE else nDoIt = %FALSE: nArrowClic = %ID_LEFT_ARROW
                ZD_SetObjectVisibility(%ID_LEFT_ARROW, nDoIt)
                ZD_GetObjectXY(%ID_FirstContact - nCountMax + 1, nX, nY): if nX > lpr.nRight then nDoIt = %TRUE else nDoIt = %FALSE: nArrowClic = %ID_RIGHT_ARROW
                ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nDoIt)

                if (nArrowClic = 0) then ZI_UpdateWindow(gP.hContact, 0)
            next
            if (ZD_IsObjectVisible(%ID_RIGHT_ARROW) = 0) then
                ZD_GetObjectXY(%ID_FirstContact - nCountMax + 1, nX, nY)
                if (nX + lpr.nBottom > lpr.nRight) then Ctrl_MapToLeft()
            end if
            if (ZD_IsObjectVisible(%ID_LEFT_ARROW) = 0) then
                ZD_GetObjectXY(%ID_FirstContact, nX, nY)
                if (nX > 0) then Ctrl_MapToRight()
            end if
            gP.nContactArrow = 0
            gP.nContactMove = 0
        end if
    end if

end sub

sub Ctrl_MapToLeft()
    local lpr as RECT
    local nCountMax, nID, K, nX, nY, nUseX as long

    GetClientRect(gP.hContact, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_MAP_LIST))
    ZD_GetObjectXY(%ID_FirstContact - nCountMax + 1, nX, nY)
    nUseX = lpr.nRight + 1
    nID = %ID_FirstContact - nCountMax + 1
    for K = nCountMax to 1 step -1
        nUseX -= lpr.nBottom
        ZD_SetObjectXY(nID, nUseX, nY, %FALSE)
        nID += 1
    next
    '// Shall we show the arrow icon?
    Ctrl_ShowContactArrow()
end sub

sub Ctrl_MapToRight()
    local lpr as RECT
    local nID, nCountMax, K, nX, nY, nUseX as long
    GetClientRect(gP.hContact, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_MAP_LIST))
    ZD_GetObjectXY(%ID_FirstContact, nX, nY)
    nID = %ID_FirstContact
    for K = 1 to nCountMax
        ZD_SetObjectXY(nID, nUseX, nY, %FALSE)
        nUseX += lpr.nBottom
        nID -= 1
    next
    '// Shall we show the arrow icon?
    Ctrl_ShowContactArrow()
end sub

sub Ctrl_IconToBottom()
    local lpr as RECT
    local nID, nCountMax, K, nX, nY, nUseY as long
    GetClientRect(gP.hSprite, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_SPRITE_LIST))
    nID = %ID_FirstSprite
    ZD_GetObjectXY(nID, nX, nY)
    for K = 1 to nCountMax
        ZD_SetObjectXY(nID, nX, nUseY, %FALSE)
        nUseY += lpr.nRight
        nID -= 1
    next
    '// Shall we show the arrow icon?
    Ctrl_ShowSpriteArrow()
end sub

sub Ctrl_IconToTop()
    local lpr as RECT
    local nID, nCountMax, K, nX, nY, nUseY as long
    GetClientRect(gP.hSprite, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_SPRITE_LIST))
    nID = %ID_FirstSprite - nCountMax + 1
    ZD_GetObjectXY(nID, nX, nY)
    nUseY = lpr.nBottom + 1
    for K = nCountMax to 1 step -1
        nUseY -= lpr.nRight
        ZD_SetObjectXY(nID, nX, nUseY, %FALSE)
        nID += 1
    next
    '// Shall we show the arrow icon?
    Ctrl_ShowSpriteArrow()
end sub

sub Ctrl_IconTopBottom(byval nUpBottom as long)
    local lpr as RECT
    local nID, K, nS, nStepY, nX, nY, nDoIt, nUseStep, nCountMax, nArrowClic as long
    GetClientRect(gP.hSprite, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_SPRITE_LIST))

    nUseStep = 1
    nUseStep = nUseStep * nUpBottom

    if (nUseStep < 0) then  '// Bottom arrow
        ZD_GetObjectXY(%ID_FirstSprite - nCountMax + 1, nX, nY)
        if (nY > lpr.nBottom) then nDoIt = -1
    else                    '// Top arrow
        ZD_GetObjectXY(%ID_FirstSprite, nX, nY)
        if (nY < 0) then nDoIt = -1
    end if

    if (nDoIt) then
        nStepY = Abs(nUseStep)
        if (gP.nSpriteMove = 0) then
            gP.nSpriteMove = 1
            for nS = 1 to lpr.nRight step nStepY
                nID = %ID_FirstSprite
                for K = 1 to nCountMax
                    ZD_GetObjectXY(nID, nX, nY)
                    ZD_SetObjectXY(nID, nX, nY + nUseStep, %FALSE)
                    nID -= 1
                next
                ZD_GetObjectXY(%ID_FirstSprite, nX, nY)
                if (nY < 0) then
                   nDoIt = %TRUE
                else
                   nDoIt = %FALSE
                   nArrowClic = %ID_TOP_ARROW
                end if
                ZD_SetObjectVisibility(%ID_TOP_ARROW, nDoIt)
                ZD_GetObjectXY(%ID_FirstSprite - nCountMax + 1, nX, nY)
                if (nY > lpr.nBottom) then
                   nDoIt = %TRUE
                else
                   nDoIt = %FALSE
                   nArrowClic = %ID_BOTTOM_ARROW
                end if
                ZD_SetObjectVisibility(%ID_BOTTOM_ARROW, nDoIt)

                if (nArrowClic = 0) then ZI_UpdateWindow(gP.hSprite, 0)
            next

            if (ZD_IsObjectVisible(%ID_BOTTOM_ARROW) = 0) then
                ZD_GetObjectXY(%ID_FirstSprite - nCountMax + 1, nX, nY)
                if (nY + lpr.nRight > lpr.nBottom) then Ctrl_IconToTop()
            end if
            if (ZD_IsObjectVisible(%ID_TOP_ARROW) = 0) then
                ZD_GetObjectXY(%ID_FirstSprite, nX, nY)
                if (nY > 0) then Ctrl_IconToBottom()
            end if

           gP.nSpriteArrow = 0
           gP.nSpriteMove = 0
        end if
    end if
    Ctrl_IconShowArrow()
end sub

sub Ctrl_ShowContactArrow()
    local lpr as RECT
    local nCountMax, nX, nY, nW, nH, nDoIt as long
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_MAP_LIST))
    if (nCountMax) then
        GetClientRect(gP.hContact, lpr)

        ZD_GetObjectXY(%ID_FirstContact, nX, nY)
        if (nX < 0) then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_SetObjectVisibility(%ID_LEFT_ARROW, nDoIt)

        ZD_GetObjectXY(%ID_FirstContact - nCountMax + 1, nX, nY)
        ZD_GetObjectBound(%ID_FirstContact - nCountMax + 1, nW, nH)
        if (nX + nW > lpr.nRight) then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nDoIt)

        ZI_UpdateWindow(gP.hContact, 0)
    end if
end sub

sub Ctrl_ShowSpriteArrow()
    local lpr as RECT
    local nCountMax, nX, nY, nW, nH, nDoIt as long
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_SPRITE_LIST))
    if (nCountMax) then
        GetClientRect(gP.hSprite, lpr)

        ZD_GetObjectXY(%ID_FirstSprite, nX, nY): if nY < 0 then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_SetObjectVisibility(%ID_TOP_ARROW, nDoIt)

        'ZD_GetObjectXY(%ID_FirstSprite - nCountMax + 1, nX, nY): IF nY > lpr.nBottom then nDoIt = %TRUE else nDoIt = %FALSE
        'ZD_SetObjectVisibility(%ID_BOTTOM_ARROW, nDoIt)
        ZD_GetObjectXY(%ID_FirstSprite - nCountMax + 1, nX, nY)
        ZD_GetObjectBound(%ID_FirstSprite - nCountMax + 1, nW, nH)
        if (nY + nH > lpr.nBottom) then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_SetObjectVisibility(%ID_BOTTOM_ARROW, nDoIt)

        ZI_UpdateWindow(gP.hContact, 0)
    end if
end sub

sub Ctrl_IconShowArrow()
    local lpr as RECT
    local K, nID, nX, nY, nUseY, nDoIt, nCountMax as long
    GetClientRect(gP.hSprite, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_SPRITE_LIST))
    if (nCountMax > 0) then
        nID = %ID_FirstSprite - nCountMax + 1
        ZD_GetObjectXY(nID, nX, nY)
        if (nY < (lpr.nBottom + 1 - lpr.nRight)) then
            nUseY = lpr.nBottom + 1

            nX = 2
            nID = %ID_FirstSprite - nCountMax + 1
            for K = nCountMax to 1 step -1
                nUseY -= lpr.nRight
                ZD_SetObjectXY(nID, nX, nUseY, %FALSE)
                nID += 1
            next

            'Ctrl_ShowSpriteArrow()
            '// Shall we show the arrow icon?
            ZD_GetObjectXY(%ID_FirstSprite, nX, nY)
            if (nY < 0) then nDoIt = %TRUE else nDoIt = %FALSE
            ZD_SetObjectVisibility(%ID_TOP_ARROW, nDoIt)
            ZD_GetObjectXY(%ID_FirstSprite - nCountMax + 1, nX, nY)
            if (nY > lpr.nBottom) then nDoIt = %TRUE else nDoIt = %FALSE
            ZD_SetObjectVisibility(%ID_BOTTOM_ARROW, nDoIt)

            ZI_UpdateWindow(gP.hSprite, 0)

        else
            ZD_GetObjectBound(%ID_TOP_ARROW, nX, nY)
            nX = (lpr.nRight - nX) * 0.5

            ZD_GetObjectXY(%ID_FirstSprite, 0, nY): if nY < 0 then nDoIt = %TRUE else nDoIt = %FALSE
            ZD_GetObjectXY(%ID_TOP_ARROW, 0, nY)
            ZD_SetObjectXY(%ID_TOP_ARROW, nX, nY, %FALSE)
            ZD_SetObjectVisibility(%ID_TOP_ARROW, nDoIt)
            ZD_GetObjectXY(%ID_FirstSprite - nCountMax + 1, 0, nY): if nY > lpr.nBottom then nDoIt = %TRUE else nDoIt = %FALSE
            ZD_GetObjectXY(%ID_BOTTOM_ARROW, 0, nY)
            ZD_SetObjectXY(%ID_BOTTOM_ARROW, nX, nY, %FALSE)
            ZD_SetObjectVisibility(%ID_BOTTOM_ARROW, nDoIt)

            ZI_UpdateWindow(gP.hSprite, 0)

        end if
    end if
end sub

sub Ctrl_MapShowArrow()
    local lpr as RECT
    local K, nID, nX, nY, nW, nH, nUseX, nDoIt, nCountMax as long

    GetClientRect(gP.hContact, lpr)
    nCountMax = ListCount(GetDlgItem(gP.hMain, %IDC_MAP_LIST))
    ZD_GetObjectXY(nCountMax, nX, nY)
    if (nX < (lpr.nRight + 1 - lpr.nBottom)) then
        nUseX = lpr.nRight + 1
        nY = 0

        nID = %ID_FirstContact - nCountMax + 1
        for K = nCountMax to 1 step -1
            nUseX -= lpr.nBottom
            ZD_SetObjectXY(nID, nUseX, nY, %FALSE)
            nID += 1
        next
        '// Shall we show the arrow icon?
        ZD_GetObjectXY(%ID_FirstContact, nX, nY): if (nX < 0) then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_SetObjectVisibility(%ID_LEFT_ARROW, nDoIt)
        ZD_GetObjectXY(%ID_FirstContact - nCountMax + 1, nX, nY): if (nX > lpr.nRight) then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nDoIt)

        ZI_UpdateWindow(gP.hContact, 0)
    else
        nID = %ID_FirstContact
        for K = 1 TO nCountMax
            ZD_GetObjectXY(nID, nX, nY)
            ZD_SetObjectXY(nID, nX, 0, %FALSE)
            nID -= 1
        next
        ZD_GetObjectBound(%ID_FirstContact, nW, nH)
        ZD_GetObjectBound(%ID_LEFT_ARROW, nX, nY)
        nY = (nH - nY) * 0.5

        ZD_GetObjectXY(%ID_FirstContact, nX, 0): if (nX < 0) then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_GetObjectXY(%ID_LEFT_ARROW, nX, 0)
        ZD_SetObjectXY(%ID_LEFT_ARROW, nX, nY, %FALSE)
        ZD_SetObjectVisibility(%ID_LEFT_ARROW, nDoIt)
        ZD_GetObjectXY(%ID_FirstContact - nCountMax + 1, nX, 0): if (nX > lpr.nRight) then nDoIt = %TRUE else nDoIt = %FALSE
        ZD_GetObjectXY(%ID_RIGHT_ARROW, nX, 0)
        ZD_SetObjectXY(%ID_RIGHT_ARROW, nX, nY, %FALSE)
        ZD_SetObjectVisibility(%ID_RIGHT_ARROW, nDoIt)

        ZI_UpdateWindow(gP.hContact, 0)

    end if
end sub

function CreateImageFromFile (zFullName as asciiz) as long
    local Img as DWORD
    if (GdipLoadImageFromFile((ucode$(zFullName)), Img) = 0) then
        function = Img
    end if
end function

function AddResource(szResource as asciiz) as DWORD
    local nIndex, nCount as long
    local hImage, hLISTFNAME, hLISTIMAGE, dwStyle as DWORD
    local zTmp as asciiz * 265
    local zData as asciiz * 16
    GetShortPathName(szResource, zTmp, SIZEOF(zTmp))
    zTmp = ucase$(zTmp)

    dwStyle = %WS_CHILD or %LBS_HASSTRINGS
    hLISTFNAME = GetDlgItem(gP.hMain, %IDC_LISTFNAME)
    if (hLISTFNAME = 0) then
        hLISTFNAME = CreateWindowEx(0, "LISTBOX", "", dwStyle, 0, 0, 0, 0, gP.hMain, %IDC_LISTFNAME, gP.hInstance, byval %NULL)
    end if
    hLISTIMAGE = GetDlgItem(gP.hMain, %IDC_LISTIMAGE)
    if (hLISTIMAGE = 0) then
        hLISTIMAGE = CreateWindowEx(0, "LISTBOX", "", dwStyle, 0, 0, 0, 0, gP.hMain, %IDC_LISTIMAGE, gP.hInstance, byval %NULL)
    end if

    if (hLISTFNAME) then
        nIndex = SendMessage(hLISTFNAME, %LB_FINDSTRING, -1, varptr(zTmp))
        if (nIndex > -1) then '// We found same resource
            SendMessage(hLISTIMAGE, %LB_GETTEXT, nIndex, varptr(zData))
            hImage = val(zData)
            '// Get full string item
            SendMessage(hLISTFNAME, %LB_GETTEXT, nIndex, varptr(zTmp))
            '// Delete item before update
            SendMessage(hLISTFNAME, %LB_DELETESTRING, nIndex, 0)
            SendMessage(hLISTIMAGE, %LB_DELETESTRING, nIndex, 0)
            szResource = left$(zTmp, LEN(zTmp) - 4)
            nCount = val(right$(zTmp, 4)) + 1
            zTmp = szResource + right$("0000" + ltrim$(str$(nCount)), 4)
            if SendMessage(hLISTFNAME, %LB_ADDSTRING, 0, varptr(zTmp)) < 0 then hImage = 0
            if SendMessage(hLISTIMAGE, %LB_ADDSTRING, 0, varptr(zData)) < 0 then hImage = 0
        else                     '// Resource doesn't exist, add it
            hImage = CreateImageFromFile(szResource)
            if (hImage) then
                zTmp = zTmp + "0001"
                if (SendMessage(hLISTFNAME, %LB_ADDSTRING, 0, varptr(zTmp)) < 0) then GdipDisposeImage(hImage)
                if (hImage) then
                    zData = str$(hImage)
                    if (SendMessage(hLISTIMAGE, %LB_ADDSTRING, 0, varptr(zData)) < 0) then hImage = 0
                end if
            end if
        end if
    end if
    function = hImage
end function

sub RemoveAllImageResource()
    local nIndex, nCount as long
    local hImage, hList as DWORD
    local zData as asciiz * 16
    hList = GetDlgItem(gP.hMain, %IDC_LISTIMAGE)
    if (hList) then
        nCount = SendMessage(hList, %LB_GETCOUNT, 0, 0)
        if (nCount > 0) then
            for nIndex = 0 to nCount -1
                SendMessage(hList, %LB_GETTEXT, nIndex, varptr(zData))
                hImage = val(zData): GdipDisposeImage(hImage)
            next
        end if
        '// Destroy LISTIMAGE
        DestroyWindow(hList)
    end if
end sub

function GetMenuText(byval ItemId as long) as string
    local sResult as string

    select case ItemId
        case %IDM_Note
             sResult = GoodMsg("Ajouter annotation","Add annotation")
        case %IDM_Clipboard
             sResult = GoodMsg("Coller presse papier","Past from clipboard")
        case %IDM_EditNote
             sResult = GoodMsg("Editer annotation","Edit annotation")
        case %IDM_EditLabel
             sResult = GoodMsg("Modifier label","Change label")
        case %IDM_NextFrame
             sResult = GoodMsg("Afficher section suivante","Display next frame")
        case %IDM_MirrorHorz
             sResult = GoodMsg("Miroir horizontal","Flip horizontaly")
        case %IDM_MirrorVert
             sResult = GoodMsg("Miroir vertical","Flip verticaly")
        case %IDM_90_Left
             sResult = GoodMsg("Pivote  gauche","Rotate counterclock")
        case %IDM_90_Right
             sResult = GoodMsg("Pivote  droite","Rotate clockwise")
        case %IDM_Up
             sResult = GoodMsg("Monter","Move up")
        case %IDM_Top
             sResult = GoodMsg("Premier plan","On top")
        case %IDM_Down
             sResult = GoodMsg("Descendre","Move down")
        case %IDM_Bottom
             sResult = GoodMsg("Arrire plan","On bottom")
        case %IDM_Flatten
             sResult = GoodMsg("Aplatir","Flatten")
        case %IDM_Clone
             sResult = GoodMsg("Cloner","Clone")
        case %IDM_Lock
             sResult = GoodMsg("Verrouiller","Lock")
        case %IDM_Delete
             sResult = GoodMsg("Supprimer","Delete")
    end select

    function = sResult
end function

function GetMenuIcon(byval ItemId as long) as DWORD
    local sItem as string
    select case ItemId
        case %IDM_Note       : sItem = "note.png"
        case %IDM_Clipboard  : sItem = "paste.png"
        case %IDM_EditNote   : sItem = "note.png"
        case %IDM_EditLabel  : sItem = "label.png"
        case %IDM_NextFrame  : sItem = "nextframe.png"
        case %IDM_MirrorHorz : sItem = "mirrorhorz.png"
        case %IDM_MirrorVert : sItem = "mirrorvert.png"
        case %IDM_90_Left    : sItem = "90_left.png"
        case %IDM_90_Right   : sItem = "90_right.png"
        case %IDM_Up         : sItem = "up.png"
        case %IDM_Top        : sItem = "top.png"
        case %IDM_Down       : sItem = "down.png"
        case %IDM_Bottom     : sItem = "bottom.png"
        case %IDM_Flatten    : sItem = "flatten.png"
        case %IDM_Clone      : sItem = "clone.png"
        case %IDM_Lock       : if gP.MenuLock then sItem = "lock.png" else sItem = "unlock.png"
        case %IDM_Delete     : sItem = "delete.png"
    end select
    function = AddResource(EXEresource()+ sItem)
end function

sub CursorWait()
    SetCursor(LoadCursor(%NULL, byval %IDC_WAIT))
end sub

function CreateDDW() as DWORD
    EnableWindow(gP.hThumbParent, %FALSE)
    EnableWindow(gP.hSpriteParent, %FALSE)
    function = skCreateDW(gP.hMain)
end function

sub DestroyDDW(byval hDW as DWORD)
    EnableWindow(gP.hThumbParent, %TRUE)
    EnableWindow(gP.hSpriteParent, %TRUE)
    skDestroyDW(hDW)
end sub

function GDImageAddSpriteTextImage() as long
    local zUseText as asciiz * 512
    local layoutRect as RECTF, boundingBox as RECTF
    local NewID, nChoice, nW, nH as long
    local hBitmap, nFam, nTempFont, nIC, nGraphics, nStrFormat, hDW as DWORD

    static zUseFont as asciiz * 256, nFontUseSize, nFontUseARGB, nFontUse3D as long

    hDW = CreateDDW()
    CursorWait()
    nChoice = ZI_FontBoxSpin(gP.hMain, $Annotation, zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D, SpinnerName())
    DestroyDDW(hDW)

    NewID = 0
    if (nChoice = 2) then
        hBitmap = ZD_CreateBitmapFromText(zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D, 0)
        if (hBitmap) then
            NewID = IncrID() '// Increment ID and ga_Sprite array

            ZD_DrawTextBitmapToCtrl(gP.hCtrl, gP.nX, gP.nY, hBitmap, nFontUseARGB, NewID, %ZS_VISIBLE)
            ZD_SetObjectQuality(NewID, gP.UseQuality, %FALSE)

            ZD_GetObjectBound(NewID, nW, nH)

            '// Create matching font
            GdipCreateFontFamilyFromName(ucode$(zUseFont), 0, nFam)
            if (nFam) then
                GdipCreateFont(nFam, nFontUseSize, 0, 2, nTempFont)
                if (nTempFont) then
                    nIC = zDisplayDC()
                    GdipCreateFromHDC(nIC, nGraphics)
                    DeleteDC(nIC)

                    GdipCreateStringFormat(0, 0, nStrFormat)
                    GdipMeasureString(nGraphics, ucode$(zUseText), len(zUseText), nTempFont, layoutRect, nStrFormat, boundingBox, byval %NULL, byval %NULL)
                    GdipDeleteStringFormat(nStrFormat)
                    GdipDeleteGraphics(nGraphics)
                    GdipDeleteFont(nTempFont)

                    local nFontH as long
                    nFontH = clng(boundingBox.nBottom)

                    ZD_SetObjectXY(NewID, gP.nX, gP.nY - clng((nH - nFontH) * 0.5), %FALSE)
                end if
                GdipDeleteFontFamily(nFam)
            end if

            ZD_SetObjectImageLabel(NewID, zUseText)
            ZD_SetObjectScroll(NewID, %TRUE)

            SpriteArrayGet(NewID)

            ga_Sprite(NewID).filename = ltrim$(str$(nFontUseSize)) + $ZLIM + _
                                        ltrim$(str$(nFontUse3D)) + $ZLIM + _
                                        zUseFont + $ZLIM + zUseText + $ZLIM

            SetFocus(gP.hCtrl)
            ZI_SetObjectFocusID(NewID)

            ZI_UpdateWindow(gP.hCtrl, %FALSE) '// Show new sprite
            ShowSaveButton()
        end if
    end if
    function = NewID
end function

function GetCtrlText(byval hCtrl as DWORD) as string
    local nLength as long, szText as asciiz * 4096
    nLength = GetWindowText(hCtrl, szText, sizeof(szText))
    if (nLength) then function = left$(szText, nLength)
end function

sub MoveHelp ()
    if (IsWindowVisible(gP.hHelp)) then
        local rc as RECT
        GetClientRect(gP.hCtrl, rc)
        MoveWindow(gP.hHelp, 174, 0, rc.nRight - 174, rc.nBottom, 1)
        PutFocusOn(gP.hHelp, 0)
    end if
end sub

function WndProc(byval hWnd as DWORD, byval Msg as DWORD, byval wParam as DWORD, byval lParam as long) as long
    local lpr, rc as RECT
    local lp as POINT
    local K, nCount, nID, newID, x, y, w, h, nRet, nState as long
    local nFontUseSize, nFontUse3D, nFontUseARGB, Choice, wmID, wmEvent as long
    local hBitmap, hCtrl, hDW as DWORD
    local zUseText AS ASCIIZ * 512
    local zUseFont AS ASCIIZ * 256

    static hBackBrush, nAnimTick as DWORD, nEditID, nShowState as long

    select case Msg

    case %WM_MOUSEMOVE
         if (ZI_IsLButtonDown()) then
             '// Use the low level API to Move the window form
             if (hWnd = gP.hThumbParent) then
                 SendMessage(hWnd, %WM_NCLBUTTONDOWN, %HTCAPTION, 0)
             elseif (hWnd = gP.hSpriteParent) then
                 SendMessage(hWnd, %WM_NCLBUTTONDOWN, %HTCAPTION, 0)
             elseif (hWnd = gP.hPannel) then
                 SendMessage(gP.hMain, %WM_NCLBUTTONDOWN, %HTCAPTION, 0)
             end if
         end if

    case %WM_CTLCOLOREDIT, %WM_CTLCOLORSTATIC
         select case long GetDlgCtrlID(lParam)
         case 0
              SetTextColor(wParam, RGB(92,92,92))
              SetBkMode(wParam, %TRANSPARENT)
              if (hBackBrush = 0) then hBackBrush = CreateSolidBrush(RGB(224,223,227))
              function = hBackBrush
              exit function
         case %IDC_ID, %IDC_LABEL, %IDC_SPRITECAPTION, %IDC_THUMBCAPTION, %IDC_ID_COORD_X, %IDC_ID_COORD_Y
              SetTextColor(wParam, RGB(2,77,220))
              SetBkMode(wParam, %TRANSPARENT)
              if (hBackBrush = 0) then hBackBrush = CreateSolidBrush(RGB(224,223,227))
              function = hBackBrush
              exit function
         end select

    case %WM_VSCROLL, %WM_HSCROLL
         if (lParam = GetDlgItem(gP.hThumbParent, %IDC_ZOOM)) then
             wmID = lo(INTEGER, wParam)
             if (wmID > %SB_LINEUP - 1) and (wmID < %SB_ENDSCROLL + 1) then
                 GDImageDrawThumbRect()
                 function = 0: exit function
             end if
         end if

    case %WM_COMMAND
         wmID = lo(INTEGER, wParam)
         wmEvent = hi(INTEGER, wParam)
         select case long (wmID)
         case %IDC_CTRL '// Copy the croped section into clipboad
              if (wmEvent = %ZM_Crop) then
                  if (lParam = 1) then
                      ZI_GetCropCoordinates(x, y, w, h)
                      ZI_PutBitmapToClipboard(ZI_CropWindowToBitmap(gP.hCtrl, x, y, w, h))
                  end if
              end if
         case %IDC_SPLIT_TOP
              if (IsWindowVisible(gP.hContact)) then
                  ShowWindow(gP.hContact, %SW_HIDE)
                  GetClientRect(lParam, rc)
                  MoveWindow(lParam, -4, 0, rc.nRight, rc.nBottom, 1)
                  ZI_SetAnchorMode(lParam, %ANCHOR_WIDTH)

                  GetWindowRect(gP.hCtrl, lpr)
                  lp.x = lpr.nLeft: lp.y = lpr.nTop
                  ScreenToClient(gP.hMain, lp)
                  lp.y = rc.nBottom
                  GetClientRect(gP.hContact, rc)
                  MoveWindow(gP.hCtrl, lp.x, lp.y, lpr.nRight - lpr.nLeft, lpr.nBottom - lpr.nTop + rc.nBottom, 1)
                  ZI_SetAnchorMode(gP.hCtrl, %ANCHOR_HEIGHT_WIDTH)
                  MoveHelp()
              else
                  GetWindowRect(gP.hCtrl, lpr)
                  lp.x = lpr.nLeft: lp.y = lpr.nTop
                  ScreenToClient(gP.hMain, lp)
                  GetClientRect(gP.hContact, rc)
                  lp.y += rc.nBottom
                  MoveWindow(gP.hCtrl, lp.x, lp.y, lpr.nRight - lpr.nLeft, lpr.nBottom - lpr.nTop - rc.nBottom, 1)
                  ZI_SetAnchorMode(gP.hCtrl, %ANCHOR_HEIGHT_WIDTH)
                  MoveHelp()

                  GetClientRect(gP.hContact, lpr)
                  GetClientRect(lParam, rc)
                  MoveWindow(lParam, -4, lpr.nBottom, rc.nRight, rc.nBottom, 1)
                  ZI_SetAnchorMode(lParam, %ANCHOR_WIDTH)
                  ShowWindow(gP.hContact, %SW_SHOW)
              end if
              SetFocus(gP.hRemoveFocus)
              GDImageDrawThumbRect()
              MoveThumb()

         case %IDC_SPLIT_BOTTOM
              if (IsWindowVisible(gP.hPannel)) then
                  ShowWindow(gP.hPannel, %SW_HIDE)
                  GetClientRect(gP.hMain, lpr)
                  GetClientRect(lParam, rc)
                  MoveWindow(lParam, -4, lpr.nBottom - rc.nBottom, rc.nRight, rc.nBottom, 1)
                  ZI_SetAnchorMode(lParam, %ANCHOR_BOTTOM_WIDTH)

                  GetWindowRect(gP.hCtrl, lpr)
                  lp.x = lpr.nLeft: lp.y = lpr.nTop
                  ScreenToClient(gP.hMain, lp)
                  GetClientRect(gP.hPannel, rc)
                  MoveWindow(gP.hCtrl, lp.x, lp.y, lpr.nRight - lpr.nLeft, lpr.nBottom - lpr.nTop + rc.nBottom, 1)
                  ZI_SetAnchorMode(gP.hCtrl, %ANCHOR_HEIGHT_WIDTH)
                  MoveHelp()
              else
                  GetWindowRect(gP.hCtrl, lpr)
                  lp.x = lpr.nLeft: lp.y = lpr.nTop
                  ScreenToClient(gP.hMain, lp)
                  GetClientRect(gP.hPannel, rc)
                  MoveWindow(gP.hCtrl, lp.x, lp.y, lpr.nRight - lpr.nLeft, lpr.nBottom - lpr.nTop - rc.nBottom, 1)
                  ZI_SetAnchorMode(gP.hCtrl, %ANCHOR_HEIGHT_WIDTH)
                  MoveHelp()

                  GetClientRect(gP.hMain, lpr)
                  GetClientRect(gP.hPannel, rc): lpr.nBottom -= rc.nBottom
                  GetClientRect(lParam, rc)
                  MoveWindow(lParam, -4, lpr.nBottom - rc.nBottom, rc.nRight, rc.nBottom, 1)
                  ZI_SetAnchorMode(lParam, %ANCHOR_BOTTOM_WIDTH)
                  ShowWindow(gP.hPannel, %SW_SHOW)
              end if
              SetFocus(gP.hRemoveFocus)
              GDImageDrawThumbRect()
              MoveThumb()

         case %IDC_OPEN
              PostMessage(gP.hMain, %WM_COMMAND, mak(long, %IDC_SPLIT_TOP, %BN_CLICKED), GetDlgItem(gP.hMain, %IDC_SPLIT_TOP))
         case %IDC_PRINT
              hDW = CreateDDW()
              ZI_PrintFull(gP.hCtrl)
              DestroyDDW(hDW)
         case %IDC_SAVEIMAGE
              ZI_SetSaveDialogMsg(GoodMsg("Choisir image","Select image"), GoodMsg("Exporter image", "Export image"), EXE.Name$) '// "Gmap_sans_nom")
              hDW = CreateDDW()
              '// Last 2 parameters used to fit image within a specific size range
              ZI_SaveLayersDialog(gP.hMain, gP.hCtrl, 0, 0, 1280, 1024)
              DestroyDDW(hDW)
         case %IDC_CROP
              ZI_EnableCropRectangle(gP.hCtrl)
         case %IDC_LOCKSPRITE
              nCount = ubound(ga_Sprite)
              if (nCount > 0) then
                  for K = 1 to nCount
                      nID = ga_Sprite(K).ID
                      if (nID) then
                          '// synchronize gMap2 ga_Sprite(nID) and GDImage zObject(nID) altogether.
                          if (ZD_IsObjectVisible(nID)) then
                              ZD_SetObjectLocked(nID, %TRUE)
                              SpriteArrayGet(nID)
                          end if
                      end if
                  next
                  ShowSaveButton()
                  skDialogInfo("", $CRLF + GoodMsg("Tous les objets visibles sont verrouills.","All the visible objects are locked."), "")
              end if
         case %IDC_SCRIPTSAVE
              SpriteArraySave()

         case %IDC_USERHELP, %IDC_USERHELP + 1
              GetClientRect(gP.hCtrl, lpr)
              if (IsWindowVisible(gP.hHelp)) then
                  ShowWindow(gP.hHelp, %SW_HIDE)
                  MoveWindow(gP.hHelp, 174, 0, lpr.nRight-174, lpr.nBottom, 0)
              else
                  MoveWindow(gP.hHelp, 174, 0, lpr.nRight-174, lpr.nBottom, 0)
                  ShowWindow(gP.hHelp, %SW_SHOW)
                  SetFocus(gP.hHelp)
              end if

         case %IDC_CLOSE
              ShallWeSave()
              PostMessage(hWnd, %WM_SYSCOMMAND, %SC_CLOSE, 0)

         case %IDM_Note
              GDImageAddSpriteTextImage()
         case %IDM_Clipboard
              if (OpenClipboard(byval %NULL)) then
                  if (EnumClipboardFormats(%CF_BITMAP)) then
                      hBitmap = GetClipboardData(%CF_BITMAP)
                      if (hBitmap) then
                          if (GetTempFileName(EXEcapture(), "cap", 0, gP.szresource)) then
                              DeleteFile(gP.szresource)
                              gP.szresource = left$(gP.szresource, len(gP.szresource) - 3) + "bmp"
                              ZI_SaveBitmapToFile(gP.szresource, hBitmap, 0)
                              hBitmap = ZI_CreateBitmapFromFile(gP.szresource, w, h)
                              if (hBitmap) then
                                  newID = IncrID() '// Increment ID and gSprite array

                                  ZD_DrawBitmapToCtrl(gP.hCtrl, gP.nX, gP.nY, hBitmap, ZD_ColorARGB(255, 0), newID, %ZS_VISIBLE)
                                  ZD_SetObjectImageLabel(newID, pathname$(NAME, gP.szresource))
                                  ZD_SetObjectScroll(newID, %TRUE)

                                  ZD_SetObjectQuality(newID, gP.UseQuality, %FALSE)

                                  SpriteArrayInit(newID, gP.szresource)  '// Initialize the global Sprite array
                                  ZI_UpdateWindow(gP.hCtrl, %FALSE)      '// Show new sprite
                                  ShowSaveButton()
                              end if
                          end if
                          EmptyClipboard()
                      end if
                  end if
                  CloseClipboard()
              end if

         case %IDM_EditNote
              nID = ZI_MouseOverObjectID()
              nFontUseSize = val(parse$(ga_Sprite(nID).filename, $ZLIM, 1))
              nFontUse3D =  val(parse$(ga_Sprite(nID).filename, $ZLIM, 2))
              zUseFont = parse$(ga_Sprite(nID).filename, $ZLIM, 3)
              zUseText = parse$(ga_Sprite(nID).filename, $ZLIM, 4)
              if (len(zUseText) = 0) then zUseText = ga_Sprite(nID).label
              nFontUseARGB = ga_Sprite(nID).ARGB

              hDW = CreateDDW()
              CursorWait()
              Choice = ZI_FontBoxSpin(gP.hMain, $Annotation, zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D, SpinnerName())
              DestroyDDW(hDW)

              if (Choice = 2) then
                  hBitmap = ZD_CreateBitmapFromText(zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D, 0)
                  if (hBitmap) then
                      ZD_SetObjectBitmapFromBitmap(hBitmap, nID, %TRUE)

                      ga_Sprite(nID).filename = ltrim$(str$(nFontUseSize)) + $ZLIM + _
                                                ltrim$(str$(nFontUse3D)) + $ZLIM + _
                                                zUseFont + $ZLIM + zUseText + $ZLIM
                      ZD_SetObjectARGBcolor(nID, nFontUseARGB)

                      SpriteArrayGet(nID)

                      ZI_UpdateWindow(gP.hCtrl, 0) '// Show new sprite
                      ShowSaveButton()
                  end if
              end if

         case %IDC_LABEL
              if (wmEvent = %EN_CHANGE) then
                  if (nEditID) then
                      ZD_SetObjectImageLabel(nID, GetCtrlText(lParam)): ShowSaveButton()
                  end if
              elseif (wmEvent = %EN_KILLFOCUS) then
                  if (nEditID) then
                      ZD_SetObjectImageLabel(nEditID, GetCtrlText(lParam))
                      SpriteArrayGet(nEditID)
                      nEditID = 0
                      EnableWindow(lParam, %FALSE)
                      ShowSaveButton()
                  end if
              end if
         case %IDM_EditLabel
              nEditID = ZI_MouseOverObjectID()
              hCtrl = GetDlgItem(gP.hPannel, %IDC_LABEL)
              EnableWindow(hCtrl, %TRUE)
              SetFocus(hCtrl)

         case %IDM_NextFrame
              nID = ZI_MouseOverObjectID()
              nCount = ZD_GetObjectFrameToUse(nID) + 1
              if (nCount > ZD_GetObjectFrameCount(nID)) then nCount = 1
              ZD_SetObjectFrameToUse(nID, nCount, %TRUE)
              SpriteArrayGet(nID)
              ShowSaveButton()
         case %IDM_MirrorHorz
              nID = ZI_MouseOverObjectID()
              ZD_FlipObjectX(nID)
              SpriteArrayGet(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_MirrorVert
              nID = ZI_MouseOverObjectID()
              ZD_FlipObjectY(nID)
              SpriteArrayGet(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_90_Left
              nID = ZI_MouseOverObjectID()
              ZD_RotateObjectCounterclock90(nID)
              SpriteArrayGet(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_90_Right
              nID = ZI_MouseOverObjectID()
              ZD_RotateObjectClockWise90(nID)
              SpriteArrayGet(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_Up
              nID = ZI_MouseOverObjectID()
              ZD_SetObjectZorder(nID, ZD_GetObjectZorder(nID) + 1)
              ga_Sprite(nID).zorder = ZD_GetObjectZorder(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_Top
              nID = ZI_MouseOverObjectID()
              ZD_SetObjectZorder(nID, %ZD_ORDER_TOP)
              ga_Sprite(nID).zorder = ZD_GetObjectZorder(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_Down
              nID = ZI_MouseOverObjectID()
              ZD_SetObjectZorder(nID, ZD_GetObjectZorder(nID) - 1)
              ga_Sprite(nID).zorder = ZD_GetObjectZorder(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_Bottom
              nID = ZI_MouseOverObjectID()
              ZD_SetObjectZorder(nID, %ZD_ORDER_BOTTOM)
              ga_Sprite(nID).zorder = ZD_GetObjectZorder(nID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_Flatten
         case %IDM_Clone
              nID = ZI_MouseOverObjectID()
              ZD_GetObjectXY(nID, x, y)
              newID = IncrID() '// Increment ID and gSprite array
              x += 16 '// We use a small offset
              y += 16 '// We use a small offset
              ZD_CloneObject(nID, newID, x, y)
              ZD_SetObjectScroll(newID, %TRUE)
              ga_Sprite(newID).filename = ga_Sprite(nID).filename
              SpriteArrayGet(newID)
              ZI_UpdateWindow(gP.hCtrl, 0)
              ShowSaveButton()
         case %IDM_Lock
              nID = ZI_MouseOverObjectID()
              if (ZD_GetObjectLocked(nID)) then
                  ZD_SetObjectLocked(nID, %FALSE)
              else
                  ZD_SetObjectLocked(nID, %TRUE)
              end if
              if (nID > 0) then ga_Sprite(nID).locked = ZD_GetObjectLocked(nID)
         case %IDM_Delete
              nCount = ubound(ga_Sprite)
              if (nCount > 0) then
                  local SpriteNull as SpriteStruct
                  nID = ZI_MouseOverObjectID()
                  ZD_DeleteObject(nID)
                  '// Because the zObj.clone property may have changed,
                  '// make sure we update the ga_Sprite().clone to replicate the GDImage zObj.clone status.
                  for K = 1 TO nCount
                      if (ga_Sprite(K).ID = nID) then
                          if (instr(1, lcase$(ga_Sprite(K).filename), EXEcapture()) = 1) then
                              DeleteFile(ga_Sprite(K).filename) '// Efface le fichier captur par copier/coller.
                          end if
                          ga_Sprite(K) = SpriteNull
                      end if
                      if ga_Sprite(K).ID then ga_Sprite(K).clone = ZD_GetObjectClone(ga_Sprite(K).ID)
                  next

                  ZI_UpdateWindow(gP.hCtrl, 0)
                  ShowSaveButton()
              end if
         end select

    case %WM_TIMER
         if (IsWindowVisible(gP.hHelp)) then
             if (nAnimTick < GetTickCount()) then
                 nAnimTick = GetTickCount() + 300
                 hCtrl = GetDlgItem(gP.hPannel, %IDC_USERHELP)
                 if (IsWindowVisible(hCtrl)) then
                     ShowWindow(hCtrl, %SW_HIDE)
                     ShowWindow(GetDlgItem(gP.hPannel, %IDC_USERHELP + 1), %SW_SHOW)
                 else
                     ShowWindow(GetDlgItem(gP.hPannel, %IDC_USERHELP + 1), %SW_HIDE)
                     ShowWindow(hCtrl, %SW_SHOW)
                 end if
             end if
         else
             hCtrl = GetDlgItem(gP.hPannel, %IDC_USERHELP + 1)
             if (IsWindowVisible(hCtrl)) then
                 ShowWindow(hCtrl, %SW_HIDE)
                 ShowWindow(GetDlgItem(gP.hPannel, %IDC_USERHELP), %SW_SHOW)
             end if
         end if
         if (wParam = %CONTACT_TIMER) then
             RenderAnimation()
             function = 0: exit function
         end if

    case %WM_MOVE
         if (hWnd = gP.hThumbParent) then
             GDImageThumbMoved()
         elseif hWnd = gP.hMain then
             MoveWindows()
         end if

    case %WM_ERASEBKGND
         GetClientRect(hWnd, rc)
         ZI_GradientPaintDC(wParam, 0, 0, rc.nRight, rc.nBottom, RGB(224,223,227), RGB(224,223,227))
         function = 1: exit function

    case %WM_DESTROY
         '// Remove all image resource from memory
         '// Must be done just before to exit the main program in case AddResource
         '// has been used to store image handles that are not tied to a specific control.
         '// For example: Image used in an ownerdrawn menu.
         DeleteObject(CaptionFont())
         RemoveAllImageResource()
         if (hBackBrush) then DeleteObject(hBackBrush): hBackBrush = 0
         PostQuitMessage(0)
         function = 0: exit function
    end select

    function = DefWindowProc(hWnd, Msg, wParam, lParam)

end function

sub DetectProject()
    if (zExist(LastMap())) then
        local BufferSize, ByttesReaded, fHandle as DWORD
        BufferSize = FileSize(LastMap())
        if (BufferSize) then
            local sBuffer, sPath, sFileName as string
            sBuffer = space$(BufferSize)
            if (zFOpen(LastMap(), 0, 2, fHandle) = 0) then
                ReadFile(fHandle, byval strptr(sBuffer), BufferSize, ByttesReaded, byval %NULL)
                zFClose(fHandle): fHandle = 0
                zSplitN(sBuffer, sPath, sFileName)
                gP.szproject = EXEmap() + sFileName
                if (zExist(gP.szproject)) then
                    SendMessage(gP.hMain, %WM_COMMAND, mak(long, %IDC_SPLIT_TOP, %BN_CLICKED), GetDlgItem(gP.hMain, %IDC_SPLIT_TOP))
                    LoadProject(gP.szproject, 0)
                else
                    gP.szproject = ""
                end if
            end if
        end if
    end if
end sub

function DummyEnumFont(lf as LOGFONT, tm as TEXTMETRIC, byval FontType as long, byref hWnd as DWORD) as long
    function = 1
end function

function WinMain (byval hInstance as DWORD, byval hPrevInstance as DWORD, _
                  byval lpCmdLine as asciiz ptr, byval nCmdShow as long) as long

    local Msg as tagMsg
    local wcx as WndClassEx
    local zClass, zTitle as asciiz * 80
    local r as RECT
    local dwStyle, dwStyleEx, hMutex, hFound, hCtrl, hDC, hRichEdit as DWORD
    local x, y, IsInitialized as long

    zClass = "GMAPZOOM"
    gP.hInstance = hInstance

    hMutex = CreateMutex(byval %Null, 0, zClass)
    if (hMutex) then
        if (GetLastError() = %ERROR_ALREADY_EXISTS) then
            do
               hFound = FindWindow(zClass, ""): if hFound then exit do
               while PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): wend
            loop
            if (IsIconic(hFound)) then ShowWindow(hFound, %SW_RESTORE)
            SetForeGroundWindow(hFound)
            function = 0
            exit function
        end if
    end if

    wcx.cbSize = sizeof(wcx)
    IsInitialized = GetClassInfoEx(gP.hInstance, zClass, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = %CS_DBLCLKS or %CS_HREDRAW or %CS_VREDRAW
        wcx.lpfnWndProc   = codeptr(WndProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = gP.hInstance
        wcx.hIcon         = LoadIcon(wcx.hInstance, "PROGRAM")
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %NULL ' GetStockObject(%BLACK_BRUSH)
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = varptr(zClass)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassEx(wcx)) then IsInitialized = %TRUE
    end if

    if (IsInitialized) then

        '// Load the GDImage.dll
        ZI_LoadDLL("") '// Replace "" with a GDImage private key to unlock the DLL.

        '// Display the loading spinner
        ZI_SpinnerInit(gP.hMain, SpinnerName(), 0)

        '// Window Styles
        dwStyleEx = 0: dwStyle = %WS_POPUP or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN or %WS_VISIBLE

        '// Adjust window to the client size
        SetRect(r, 0, 0, %CLIENT_WIDTH, %CLIENT_HEIGHT)
        AdjustWindowRectEx(r, dwStyle, %FALSE, dwStyleEx)
        MinTrackSizeW(r.nRight - r.nLeft)
        MinTrackSizeH(r.nBottom - r.nTop)
        x = max&((GetSystemMetrics(%SM_CXSCREEN) - MinTrackSizeW(0) - 100) \ 2, 0)
        y = max&((GetSystemMetrics(%SM_CYSCREEN) - MinTrackSizeH(0)) \ 2, 0)

        '// Create the MAIN window (and show it out of viewport, to display correctly the contact sheet the 1st time)
        zTitle = "gMap2 - GDImage " + ZI_Version()
        gP.hMain = CreateWindowExA(dwStyleEx, zClass, zTitle, _
                                   dwStyle, x, y -10000, MinTrackSizeW(0), MinTrackSizeH(0), %NULL, %NULL, gP.hInstance, byval %NULL)

        if (gP.hMain) then
            hRichEdit = LoadLibrary("RICHED20.DLL")

            if (skInitEngine("gMap2.sks", "")) then
                skSkinWindow(gP.hMain, "Dock|Undock|Minimize|Maximize|Restore|Close")
                skDoNotSkinPopupMenu(1,1)
            end if
            MakeDir(EXEcapture())

            gP.UseQuality = %InterpolationModeHighQuality
            '// Create child controls
            CreateChildControls(zClass)

            '// We use a callback to monitor the messages from the GDImage controls
            GDImageEnableEvents()

            DetectProject()
            BuildMapCtrl()
            DetectSprite()
            BuildIconCtrl()

            '// Show all windows at their correct location
            GetWindowRect(gP.hMain, r)
            MoveWindow(gP.hMain, r.nLeft, r.nTop + 10000, r.nRight - r.nLeft, r.nBottom - r.nTop, %TRUE)
            ShowWindow(gP.hThumbParent, %SW_SHOW)
            ShowWindow(gP.hSpriteParent, %SW_SHOW)
            SetForegroundWindow(gP.hMain)                  ' Slightly Higher Priority
            SetFocus(gP.hMain)                             ' Sets Keyboard Focus to The Window

            '// Speedup font detection
            hDC = GetDC(gP.hMain)
            EnumFontFamilies(hDC, BYVAL %NULL, CODEPTR(DummyEnumFont), BYVAL 0)           
            ReleaseDC(gP.hMain, hDC)

            '// Remove the spinner
            ZI_SpinnerClose()

            SetTimer(gP.hMain, %CONTACT_TIMER, 40, %NULL)
            while GetMessage(Msg, %NULL, 0, 0)
               if (IsDialogMessage(gP.hMain, Msg) = %FALSE) then
                   TranslateMessage(msg)                ' Translate The Message
                   DispatchMessage(msg)                 ' Dispatch The Message
               end if
            wend
            KillTimer(gP.hMain, %CONTACT_TIMER)

            if (hRichEdit) then FreeLibrary(hRichEdit)

            function = msg.wParam

        end if

    end if

    if (hMutex) then CloseHandle(hMutex)

end function
